//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//| SharedMemory.cpp:     DLL.                                                                                                       |
//|          4.                                                                                       |
//| Copyright  2010,   (Zhunko)                                                                                                                               |
//| e-mail: vadim@zhunko.ru                                                                                                                     30.03.2010 - 07.02.2014  |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|             .         (      |
//|)    .                  |
//|,          .               |
//| .             .            |
//|,      .            . ,  |
//|   .                                                                                                                                |
//|            .    -1,      ,   |
//|,     .        ,            |
//|.       .                                                                                                            |
//|   , ,   ,     ,    .    "MemoryCreateProjection()"        |
//|"MemoryOpenProjection()"             .    /     |
//|      .  ,      ,   .                                                   |
//|    "MemoryCreate()"   "MemoryOpen()"       ,            |
//|       "MemoryCloseHandle()".                       |
//|  .      "MemoryProjection()"               |
//| .                                                                                                                                                 |
//|         .     /            |
//| .                                                                                                                                                   |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|    :                                                                                                                                         |
//| 1.  .       .                                                                                      |
//| 2.     .         .                                                    |
//| 3.      .          .                                          |
//|           (    ) :     |
//| -    25;                                                                                                                                        |
//| -       50;                                                                                                                       |
//| -        100.                                                                                                                 |
//|    "MemoryInit()"       .     5240         |
//|5764   -  .                                                                                                           |
//|                                                                                                                                                                      |
//|         (    ) :                |
//| -    1;                                                                                                                                         |
//| -       1;                                                                                                                        |
//| -        1.                                                                                                                   |
//|  ,           ,        .    |
//|        ,       .        .                     |
//|  ,    .                                                                                                                                  |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//| 146    7 .                                                                                                                                    |
//| 1.   .                                                                                                                                 |
//| 2.  .                                                                                                                                                    |
//| 3.              .                                           |
//| 4.         .                                                                                                                |
//| 5.         .                                                                                                               |
//| 6.       .                                                                                                                     |
//| 7.       .                                                                                                                    |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
#ifndef EXPFUNC
 #define EXPFUNC(type)   __declspec(dllexport) type __stdcall
#endif
//
// 1.       .    
//
// 1.1.            .    .
//      ,       (   )    .      .
EXPFUNC(VOID) MemoryInit(const int nUserClassesGlobal,   //        .
                         const int nUserClassesTerminal, //        .
                         const int nUserClassesWindow);  //        .
//==============================================================================================================================================================================================================================================================
// 1.2.           .  ,   .
EXPFUNC(VOID) MemoryInitDebug(const int nProcessID); //    4.    - .
//
// 2.      .    
//
// 2.1.1.      .      -1.    ANSI-.
EXPFUNC(INT) MemoryActiveA(const int nArea,         //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                           LPCSTR    szPrefixArea); //         .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.2.      .      -1.    UNICODE-.
EXPFUNC(INT) MemoryActiveW(const int nArea,         //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                           LPCWSTR   szPrefixArea); //         .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.3.      .      -1.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryActive  MemoryActiveW
#else
 #define MemoryActive  MemoryActiveA
#endif
//==============================================================================================================================================================================================================================================================
// 2.2.1.             .         .   
//                  .                  .
//          "nIndex"  -1,     ,    .      NULL.    ANSI-.
EXPFUNC(HANDLE) MemoryCreateA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                              LPCSTR       szPrefixArea, //         .
                              const HANDLE hFileUser,    //    .
                              const int    nIndex,       //   .   ,   .
                              LPCSTR       szName,       //   .
                              const int    nSize);       //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.2.2.             .         .   
//                  .                  .
//          "nIndex"  -1,     ,    .      NULL.    UNICODE-.
EXPFUNC(HANDLE) MemoryCreateW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                              LPCWSTR      szPrefixArea, //         .
                              const HANDLE hFileUser,    //    .
                              const int    nIndex,       //   .   ,   .
                              LPCWSTR      szName,       //   .
                              const int    nSize);       //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.2.3.             .         .   
//                  .                  .
//          "nIndex"  -1,     ,    .      NULL.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryCreate  MemoryCreateW
#else
 #define MemoryCreate  MemoryCreateA
#endif
//==============================================================================================================================================================================================================================================================
// 2.3.1.    TRUE,       ,   FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryCheckIndexA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                                LPCSTR    szPrefixArea, //         .
                                const int nIndex);      //   .   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.3.2.    TRUE,       ,   FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryCheckIndexW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                                LPCWSTR   szPrefixArea, //         .
                                const int nIndex);      //   .   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.3.3.    TRUE,       ,   FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryCheckIndex  MemoryCheckIndexW
#else
 #define MemoryCheckIndex  MemoryCheckIndexA
#endif
//==============================================================================================================================================================================================================================================================
// 2.4.1.    TRUE,       ,   FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryCheckNameA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                       //                 MEMORY_TERMINAL    .
                                                       //                 MEMORY_WINDOW      .
                               LPCSTR    szPrefixArea, //         .
                               LPCSTR    szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.4.2.    TRUE,       ,   FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryCheckNameW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                       //                 MEMORY_TERMINAL    .
                                                       //                 MEMORY_WINDOW      .
                               LPCWSTR   szPrefixArea, //         .
                               LPCWSTR   szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.4.3.    TRUE,       ,   FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryCheckName  MemoryCheckNameW
#else
 #define MemoryCheckName  MemoryCheckNameA
#endif
//==============================================================================================================================================================================================================================================================
// 2.5.1.    .   TRUE     FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryClearA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                                 LPCSTR szPrefixArea, //         .
                           const int    nIndex,       //   .   ,   .
                                 LPCSTR szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.5.2.    .   TRUE     FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryClearW(const int     nArea,        //  : MEMORY_GLOBAL      .
                                                       //                 MEMORY_TERMINAL    .
                                                       //                 MEMORY_WINDOW      .
                                 LPCWSTR szPrefixArea, //         .
                           const int     nIndex,       //   .   ,   .
                                 LPCWSTR szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.5.3.    .   TRUE     FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryClear  MemoryClearW
#else
 #define MemoryClear  MemoryClearA
#endif
//==============================================================================================================================================================================================================================================================
// 2.6.1.          .      ,        .
//          TRUE       ,  FALSE,       .    ANSI-.
EXPFUNC(BOOL) MemoryCloseAllA(const int nArea,         //  : MEMORY_GLOBAL      .
                                                       //                 MEMORY_TERMINAL    .
                                                       //                 MEMORY_WINDOW      .
                              LPCSTR    szPrefixArea,  //         .
                              LPCSTR    szNamePrefix); //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.6.2.          .      ,        .
//          TRUE       ,  FALSE,       .    UNICODE-.
EXPFUNC(BOOL) MemoryCloseAllW(const int nArea,         //  : MEMORY_GLOBAL      .
                                                       //                 MEMORY_TERMINAL    .
                                                       //                 MEMORY_WINDOW      .
                              LPCWSTR   szPrefixArea,  //         .
                              LPCWSTR   szNamePrefix); //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.6.3.          .      ,        .
//          TRUE       ,  FALSE,       .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryCloseAll  MemoryCloseAllW
#else
 #define MemoryCloseAll  MemoryCloseAllA
#endif
//==============================================================================================================================================================================================================================================================
// 2.7.1.      .   TRUE   ,  FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryCloseHandleA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                            //                 MEMORY_TERMINAL    .
                                                            //                 MEMORY_WINDOW      .
                                 LPCSTR       szPrefixArea, //         .
                                 const HANDLE hMemory);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.7.2.      .   TRUE   ,  FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryCloseHandleW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                            //                 MEMORY_TERMINAL    .
                                                            //                 MEMORY_WINDOW      .
                                 LPCWSTR      szPrefixArea, //         .
                                 const HANDLE hMemory);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.7.3.      .   TRUE   ,  FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryCloseHandle  MemoryCloseHandleW
#else
 #define MemoryCloseHandle  MemoryCloseHandleA
#endif
//==============================================================================================================================================================================================================================================================
// 2.8.1.               .    ANSI-.
//          TRUE       ,  FALSE,       .
EXPFUNC(BOOL) MemoryCloseHandleFileA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                   LPCSTR       szPrefixArea, //         .
                                   const HANDLE hFileUser);   //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.8.2.               .    UNICODE-.
//          TRUE       ,  FALSE,       .
EXPFUNC(BOOL) MemoryCloseHandleFileW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                                //                 MEMORY_TERMINAL    .
                                                                //                 MEMORY_WINDOW      .
                                     LPCWSTR      szPrefixArea, //         .
                                     const HANDLE hFileUser);   //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.8.3.               .       .
//          TRUE       ,  FALSE,       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryCloseHandleFile  MemoryCloseHandleFileW
#else
 #define MemoryCloseHandleFile  MemoryCloseHandleFileA
#endif
//==============================================================================================================================================================================================================================================================
// 2.9.1.         .   TRUE       ,  FALSE,       .    ANSI-.
EXPFUNC(BOOL) MemoryCloseNameA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                       //                 MEMORY_TERMINAL    .
                                                       //                 MEMORY_WINDOW      .
                               LPCSTR    szPrefixArea, //         .
                               LPCSTR    szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.9.2.         .   TRUE       ,  FALSE,       .    UNICODE-.
EXPFUNC(BOOL) MemoryCloseNameW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                       //                 MEMORY_TERMINAL    .
                                                       //                 MEMORY_WINDOW      .
                               LPCWSTR   szPrefixArea, //         .
                               LPCWSTR   szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.9.3.         .   TRUE       ,  FALSE,       .
//              .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryCloseName  MemoryCloseNameW
#else
 #define MemoryCloseName  MemoryCloseNameA
#endif
//==============================================================================================================================================================================================================================================================
// 2.10.1.      .      -1.    ANSI-.
EXPFUNC(INT) MemoryFreeClassesA(const int nArea,         //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                                LPCSTR    szPrefixArea); //         .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.10.2.      .      -1.    UNICODE-.
EXPFUNC(INT) MemoryFreeClassesW(const int nArea,         //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                                LPCWSTR   szPrefixArea); //         .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.10.3.      .      -1.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryFreeClasses  MemoryFreeClassesW
#else
 #define MemoryFreeClasses  MemoryFreeClassesA
#endif
//==============================================================================================================================================================================================================================================================
// 2.11.1.              .       .    ANSI-.
EXPFUNC(LPSTR) MemoryFullNameByIndexA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                      LPCSTR    szPrefixArea, //         .
                                      const int nIndex);      //   .   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.11.2.              .       .    UNICODE-.
EXPFUNC(LPWSTR) MemoryFullNameByIndexW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                               //                 MEMORY_TERMINAL    .
                                                               //                 MEMORY_WINDOW      .
                                       LPCWSTR   szPrefixArea, //         .
                                       const int nIndex);      //   .   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.11.3.              .       .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryFullNameByIndex  MemoryFullNameByIndexW
#else
 #define MemoryFullNameByIndex  MemoryFullNameByIndexA
#endif
//==============================================================================================================================================================================================================================================================
// 2.12.1.          -1   .    ANSI-.
//             :  0     ;
//                                             -1      ID  ;
//                                             -2     .
EXPFUNC(INT) MemoryIndexByNameA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                                LPCSTR    szPrefixArea, //         .
                                LPCSTR    szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.12.2.          -1   .    UNICODE-.
//             :  0     ;
//                                             -1      ID  ;
//                                             -2     .
EXPFUNC(INT) MemoryIndexByNameW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                                LPCWSTR   szPrefixArea, //         .
                                LPCWSTR   szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.12.3.          -1   .       .
//             :  0     ;
//                                             -1      ID  ;
//                                             -2     .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryIndexByName  MemoryIndexByNameW
#else
 #define MemoryIndexByName  MemoryIndexByNameA
#endif
//==============================================================================================================================================================================================================================================================
// 2.13.1.    .         ,  NULL.         ,    NULL.
//            ANSI-.
EXPFUNC(HANDLE) MemoryOpenA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                            LPCSTR    szPrefixArea, //         .
                            const int nIndex,       //   .   ,   .
                            LPCSTR    szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.13.2.    .         ,  NULL.         ,    NULL.
//            UNICODE-.
EXPFUNC(HANDLE) MemoryOpenW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                            LPCWSTR   szPrefixArea, //         .
                            const int nIndex,       //   .   ,   .
                            LPCWSTR   szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.13.3.    .         ,  NULL.         ,    NULL.
//               .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryOpen  MemoryOpenW
#else
 #define MemoryOpen  MemoryOpenA
#endif
//==============================================================================================================================================================================================================================================================
// 2.14.1.        .   TRUE   ,  FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryResizeA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                            LPCSTR    szPrefixArea, //         .
                            const int nIndex,       //   .   ,   .
                            LPCSTR    szName,       //   .
                            const int nSize);       //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.14.2.        .   TRUE   ,  FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryResizeW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                            LPCWSTR   szPrefixArea, //         .
                            const int nIndex,       //   .   ,   .
                            LPCWSTR   szName,       //   .
                            const int nSize);       //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.14.3.        .   TRUE   ,  FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryResize  MemoryResizeW
#else
 #define MemoryResize  MemoryResizeA
#endif
//==============================================================================================================================================================================================================================================================
// 2.15.1.       .   TRUE     FALSE.    ANSI-.
EXPFUNC(BOOL) MemorySetA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                         LPCSTR    szPrefixArea, //         .
                         const int nIndex,       //   .   ,   .
                         LPCSTR    szName,       //   .
                         const int nStartByte,   //     ,     .
                         const int nValue,       //    .       . , ,   WORD,    2 .
                         const int nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.15.2.       .   TRUE     FALSE.    UNICODE-.
EXPFUNC(BOOL) MemorySetW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                         LPCWSTR   szPrefixArea, //         .
                         const int nIndex,       //   .   ,   .
                         LPCWSTR   szName,       //   .
                         const int nStartByte,   //     ,     .
                         const int nValue,       //    .       . , ,   WORD,    2 .
                         const int nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.15.3.       .   TRUE     FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemorySet  MemorySetW
#else
 #define MemorySet  MemorySetA
#endif
//==============================================================================================================================================================================================================================================================
// 2.16.1.          .    ANSI-.
EXPFUNC(INT) MemorySizeA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                         LPCSTR    szPrefixArea, //         .
                         const int nIndex,       //   .   ,   .
                         LPCSTR    szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.16.2.          .    UNICODE-.
EXPFUNC(INT) MemorySizeW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                         LPCWSTR   szPrefixArea, //         .
                         const int nIndex,       //   .   ,   .
                         LPCWSTR   szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.16.3.          .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemorySet  MemorySetW
#else
 #define MemorySet  MemorySetA
#endif
//==============================================================================================================================================================================================================================================================
// 2.17.1.         .       .    ANSI-.
EXPFUNC(LPSTR) MemoryUserNameByIndexA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                      LPCSTR    szPrefixArea, //         .
                                      const int nIndex);      //   .   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.17.2.         .       .    UNICODE-.
EXPFUNC(LPWSTR) MemoryUserNameByIndexW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                               //                 MEMORY_TERMINAL    .
                                                               //                 MEMORY_WINDOW      .
                                       LPCWSTR   szPrefixArea, //         .
                                       const int nIndex);      //   .   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.17.3.         .       .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryUserNameByIndex  MemoryUserNameByIndexW
#else
 #define MemoryUserNameByIndex  MemoryUserNameByIndexA
#endif
//
// 3.                  .    
//
// 3.1.1.           /               
//               .               ,  NULL.
//           ANSI-.
EXPFUNC(SIZE_T) MemoryCreateProjectionA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                                   //                 MEMORY_TERMINAL    .
                                                                   //                 MEMORY_WINDOW      .
                                        LPCSTR       szPrefixArea, //         .
                                        const HANDLE hFileUser,    //    .
                                        const int    nIndex,       //   .   ,   .
                                        LPCSTR       szName,       //   .
                                        const int    nSize);       //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.1.2.           /               
//               .               ,  NULL.
//           UNICODE-.
EXPFUNC(SIZE_T) MemoryCreateProjectionW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                                   //                 MEMORY_TERMINAL    .
                                                                   //                 MEMORY_WINDOW      .
                                        LPCWSTR      szPrefixArea, //         .
                                        const HANDLE hFileUser,    //    .
                                        const int    nIndex,       //   .   ,   .
                                        LPCWSTR      szName,       //   .
                                        const int    nSize);       //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.1.3.           /               
//               .               ,  NULL.
//              .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryCreateProjection  MemoryCreateProjectionW
#else
 #define MemoryCreateProjection  MemoryCreateProjectionA
#endif
//==============================================================================================================================================================================================================================================================
// 3.2.1.                 .
//                      ,  NULL.
//           ANSI-.
EXPFUNC(SIZE_T) MemoryOpenProjectionA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                      LPCSTR    szPrefixArea, //         .
                                      const int nIndex,       //   .   ,   .
                                      LPCSTR    szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.2.2.                 .
//                      ,  NULL.
//           UNICODE-.
EXPFUNC(SIZE_T) MemoryOpenProjectionW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                      LPCWSTR   szPrefixArea, //         .
                                      const int nIndex,       //   .   ,   .
                                      LPCWSTR   szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.2.3.                 .
//                      ,  NULL.
//              .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryOpenProjection  MemoryOpenProjectionW
#else
 #define MemoryOpenProjection  MemoryOpenProjectionA
#endif
//==============================================================================================================================================================================================================================================================
// 3.3.1.          .
//               :  (nIndex),  (szName),  (pcAddress).
//              TRUE  FALSE   .    ANSI-.
EXPFUNC(BOOL) MemoryUnProjectionA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                             //                 MEMORY_TERMINAL    .
                                                             //                 MEMORY_WINDOW      .
                                  LPCSTR       szPrefixArea, //         .
                                  const int    nIndex,       //   .   ,   .
                                  LPCSTR       szName,       //   .
                                  const SIZE_T stAddress);   //          .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.3.2.          .
//               :  (nIndex),  (szName),  (pcAddress).
//              TRUE  FALSE   .    UNICODE-.
EXPFUNC(BOOL) MemoryUnProjectionW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                             //                 MEMORY_TERMINAL    .
                                                             //                 MEMORY_WINDOW      .
                                  LPCWSTR      szPrefixArea, //         .
                                  const int    nIndex,       //   .   ,   .
                                  LPCWSTR      szName,       //   .
                                  const SIZE_T stAddress);   //          .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.3.3.          .
//               :  (nIndex),  (szName),  (pcAddress).
//              TRUE  FALSE   .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryUnProjection  MemoryUnProjectionW
#else
 #define MemoryUnProjection  MemoryUnProjectionA
#endif
//==============================================================================================================================================================================================================================================================
// 3.4.1.               .
//                      ,  NULL.    ANSI-.
EXPFUNC(SIZE_T) MemoryProjectionByHandleA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                                     //                 MEMORY_TERMINAL    .
                                                                     //                 MEMORY_WINDOW      .
                                          LPCSTR       szPrefixArea, //         .
                                          const int    nIndex,       //   .   ,   .
                                          const HANDLE hMemory);     //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.4.2.               .
//                      ,  NULL.    UNICODE-.
EXPFUNC(SIZE_T) MemoryProjectionByHandleW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                                     //                 MEMORY_TERMINAL    .
                                                                     //                 MEMORY_WINDOW      .
                                          LPCWSTR      szPrefixArea, //         .
                                          const int    nIndex,       //   .   ,   .
                                          const HANDLE hMemory);     //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.4.3.               .
//                      ,  NULL.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryProjectionByHandle  MemoryProjectionByHandleW
#else
 #define MemoryProjectionByHandle  MemoryProjectionByHandleA
#endif
//==============================================================================================================================================================================================================================================================
// 3.5.1.               .
//                      ,  NULL.    ANSI-.
EXPFUNC(SIZE_T) MemoryProjectionByNameA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                                //                 MEMORY_TERMINAL    .
                                                                //                 MEMORY_WINDOW      .
                                        LPCSTR    szPrefixArea, //         .
                                        const int nIndex,       //   .   ,   .
                                        LPCSTR    szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.5.2.               .
//                      ,  NULL.    UNICODE-.
EXPFUNC(SIZE_T) MemoryProjectionByNameW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                                //                 MEMORY_TERMINAL    .
                                                                //                 MEMORY_WINDOW      .
                                        LPCWSTR   szPrefixArea, //         .
                                        const int nIndex,       //   .   ,   .
                                        LPCWSTR   szName);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.5.3.               .
//                      ,  NULL.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryProjectionByName  MemoryProjectionByNameW
#else
 #define MemoryProjectionByName  MemoryProjectionByNameA
#endif
//
// 4.             .    
//
// 4.1.1.           BOOL (1 )     .
//          TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteBoolA(const int  nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                               LPCSTR     szPrefixArea, //         .
                               const int  nIndex,       //   .   ,   .
                               LPCSTR     szName,       //   .
                               const int  nStartByte,   //      ,     .
                               const bool bValue);      //   BOOL (1 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.1.2.           BOOL (1 )     .
//          TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteBoolW(const int  nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                               LPCWSTR    szPrefixArea, //         .
                               const int  nIndex,       //   .   ,   .
                               LPCWSTR    szName,       //   .
                               const int  nStartByte,   //      ,     .
                               const bool bValue);      //   BOOL (1 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.1.3.           BOOL (1 )     .
//          TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteBool  MemoryWriteBoolW
#else
 #define MemoryWriteBool  MemoryWriteBoolA
#endif
//==============================================================================================================================================================================================================================================================
// 4.2.1.           CHAR (1 )     .     INT (4 )  CHAR (1 )     .
//          TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteCharA(const int  nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                               LPCSTR     szPrefixArea, //         .
                               const int  nIndex,       //   .   ,   .
                               LPCSTR     szName,       //   .
                               const int  nStartByte,   //      ,     .
                               const CHAR cValue);      //   CHAR (1 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.2.2.           CHAR (1 )     .     INT (4 )  CHAR (1 )     .
//          TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteCharW(const int  nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                               LPCWSTR    szPrefixArea, //         .
                               const int  nIndex,       //   .   ,   .
                               LPCWSTR    szName,       //   .
                               const int  nStartByte,   //      ,     .
                               const CHAR cValue);      //   CHAR (1 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.2.3.           CHAR (1 )     .     INT (4 )  CHAR (1 )     .
//          TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteChar  MemoryWriteCharW
#else
 #define MemoryWriteChar  MemoryWriteCharA
#endif
//==============================================================================================================================================================================================================================================================
// 4.3.1.           UCHAR (1 )     .
//          TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteUCharA(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                LPCSTR      szPrefixArea, //         .
                                const int   nIndex,       //   .   ,   .
                                LPCSTR      szName,       //   .
                                const int   nStartByte,   //      ,     .
                                const UCHAR ucValue);     //   UCHAR (1 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.3.2.           UCHAR (1 )     .
//          TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteUCharW(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                LPCWSTR     szPrefixArea, //         .
                                const int   nIndex,       //   .   ,   .
                                LPCWSTR     szName,       //   .
                                const int   nStartByte,   //      ,     .
                                const UCHAR ucValue);     //   UCHAR (1 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.3.3.           UCHAR (1 )     .
//          TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteUChar  MemoryWriteUCharW
#else
 #define MemoryWriteUChar  MemoryWriteUCharA
#endif
//==============================================================================================================================================================================================================================================================
// 4.4.1.           SHORT (2 )     .
//          TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteShortA(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                LPCSTR      szPrefixArea, //         .
                                const int   nIndex,       //   .   ,   .
                                LPCSTR      szName,       //   .
                                const int   nStartByte,   //      ,     .
                                const SHORT shValue);     //   SHORT (2 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.4.2.           SHORT (2 )     .
//          TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteShortW(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                LPCWSTR     szPrefixArea, //         .
                                const int   nIndex,       //   .   ,   .
                                LPCWSTR     szName,       //   .
                                const int   nStartByte,   //      ,     .
                                const SHORT shValue);     //   SHORT (2 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.4.3.           SHORT (2 )     .
//          TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteShort  MemoryWriteShortW
#else
 #define MemoryWriteShort  MemoryWriteShortA
#endif
//==============================================================================================================================================================================================================================================================
// 4.5.1.           USHORT (2 )     .
//          TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteUShortA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                                 LPCSTR    szPrefixArea, //         .
                                 const int nIndex,       //   .   ,   .
                                 LPCSTR    szName,       //   .
                                 const int nStartByte,   //      ,     .
                                 const USHORT ushValue); //   USHORT (2 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.5.2.           USHORT (2 )     .
//          TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteUShortW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                            //                 MEMORY_TERMINAL    .
                                                            //                 MEMORY_WINDOW      .
                                 LPCWSTR      szPrefixArea, //         .
                                 const int    nIndex,       //   .   ,   .
                                 LPCWSTR      szName,       //   .
                                 const int    nStartByte,   //      ,     .
                                 const USHORT ushValue);    //   USHORT (2 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.5.3.           USHORT (2 )     .     INT (4 )  USHORT (2 )     .
//          TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteUShort  MemoryWriteUShortW
#else
 #define MemoryWriteUShort  MemoryWriteUShortA
#endif
//==============================================================================================================================================================================================================================================================
// 4.6.1.           INT (4 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteIntA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                              LPCSTR    szPrefixArea, //         .
                              const int nIndex,       //   .   ,   .
                              LPCSTR    szName,       //   .
                              const int nStartByte,   //      ,     .
                              const int nValue);      //   INT (4 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.6.2.           INT (4 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteIntW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                              LPCWSTR   szPrefixArea, //         .
                              const int nIndex,       //   .   ,   .
                              LPCWSTR   szName,       //   .
                              const int nStartByte,   //      ,     .
                              const int nValue);      //   INT (4 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.6.3.           INT (4 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteInt  MemoryWriteIntW
#else
 #define MemoryWriteInt  MemoryWriteIntA
#endif
//==============================================================================================================================================================================================================================================================
// 4.7.1.           UINT (4 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteUIntA(const int  nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                               LPCSTR     szPrefixArea, //         .
                               const int  nIndex,       //   .   ,   .
                               LPCSTR     szName,       //   .
                               const int  nStartByte,   //      ,     .
                               const UINT uiValue);     //   UINT (4 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.7.2.           UINT (4 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteUIntW(const int  nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                               LPCWSTR    szPrefixArea, //         .
                               const int  nIndex,       //   .   ,   .
                               LPCWSTR    szName,       //   .
                               const int  nStartByte,   //      ,     .
                               const UINT uiValue);     //   UINT (4 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.7.3.           UINT (4 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteUInt  MemoryWriteUIntW
#else
 #define MemoryWriteUInt  MemoryWriteUIntA
#endif
//==============================================================================================================================================================================================================================================================
// 4.8.1.           INT64 (8 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteLongA(const int nArea,          //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                               LPCSTR      szPrefixArea, //         .
                               const int   nIndex,       //   .   ,   .
                               LPCSTR      szName,       //   .
                               const int   nStartByte,   //      ,     .
                               const INT64 i64Value);    //   INT64 (8 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.8.2.           INT64 (8 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteLongW(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                               LPCWSTR     szPrefixArea, //         .
                               const int   nIndex,       //   .   ,   .
                               LPCWSTR     szName,       //   .
                               const int   nStartByte,   //      ,     .
                               const INT64 i64Value);    //   INT64 (8 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.8.3.           INT64 (8 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteLong  MemoryWriteLongW
#else
 #define MemoryWriteLong  MemoryWriteLongA
#endif
//==============================================================================================================================================================================================================================================================
// 4.9.1.           UINT64 (8 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteULongA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                           //                 MEMORY_TERMINAL    .
                                                           //                 MEMORY_WINDOW      .
                                LPCSTR       szPrefixArea, //         .
                                const int    nIndex,       //   .   ,   .
                                LPCSTR       szName,       //   .
                                const int    nStartByte,   //      ,     .
                                const UINT64 ui64Value);   //   UINT64 (8 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.9.2.           UINT64 (8 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteULongW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                           //                 MEMORY_TERMINAL    .
                                                           //                 MEMORY_WINDOW      .
                                LPCWSTR      szPrefixArea, //         .
                                const int    nIndex,       //   .   ,   .
                                LPCWSTR      szName,       //   .
                                const int    nStartByte,   //      ,     .
                                const UINT64 ui64Value);   //   UINT64 (8 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.9.3.           UINT64 (8 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteULong  MemoryWriteULongW
#else
 #define MemoryWriteULong  MemoryWriteULongA
#endif
//==============================================================================================================================================================================================================================================================
// 4.10.1.           FLOAT (4 )     .
//           TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteFloatA(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                LPCSTR      szPrefixArea, //         .
                                const int   nIndex,       //   .   ,   .
                                LPCSTR      szName,       //   .
                                const int   nStartByte,   //      ,     .
                                const float fValue);      //   FLOAT (4 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.10.2.           FLOAT (4 )     .
//           TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteFloatW(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                LPCWSTR     szPrefixArea, //         .
                                const int   nIndex,       //   .   ,   .
                                LPCWSTR     szName,       //   .
                                const int   nStartByte,   //      ,     .
                                const float fValue);      //   FLOAT (4 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.10.3.           FLOAT (4 )     .
//           TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteFloat  MemoryWriteFloatW
#else
 #define MemoryWriteFloat  MemoryWriteFloatA
#endif
//==============================================================================================================================================================================================================================================================
// 4.11.1.           DOUBLE (8 )     .    ,   .
//           TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteDoubleA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                            //                 MEMORY_TERMINAL    .
                                                            //                 MEMORY_WINDOW      .
                                 LPCSTR       szPrefixArea, //         .
                                 const int    nIndex,       //   .   ,   .
                                 LPCSTR       szName,       //   .
                                 const int    nStartByte,   //      ,     .
                                 const double dValue);      //   DOUBLE (8 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.11.2.           DOUBLE (8 )     .    ,   .
//           TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteDoubleW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                            //                 MEMORY_TERMINAL    .
                                                            //                 MEMORY_WINDOW      .
                                 LPCWSTR      szPrefixArea, //         .
                                 const int    nIndex,       //   .   ,   .
                                 LPCWSTR      szName,       //   .
                                 const int    nStartByte,   //      ,     .
                                 const double dValue);      //   DOUBLE (8 )     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.11.3.           DOUBLE (8 )     .    ,   .
//           TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteDouble  MemoryWriteDoubleW
#else
 #define MemoryWriteDouble  MemoryWriteDoubleA
#endif
//==============================================================================================================================================================================================================================================================
// 4.12.1.         ANSI-     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteStringA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                                 LPCSTR    szPrefixArea, //         .
                                 const int nIndex,       //   .   ,   .
                                 LPCSTR    szName,       //   .
                                 const int nStartByte,   //      ,     .
                                 LPCSTR    szString);    //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.12.2.         UNICODE-     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteStringW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                                 LPCWSTR   szPrefixArea, //         .
                                 const int nIndex,       //   .   ,   .
                                 LPCWSTR   szName,       //   .
                                 const int nStartByte,   //      ,     .
                                 LPCWSTR   szString);    //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.12.3.                .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteString  MemoryWriteStringW
#else
 #define MemoryWriteString  MemoryWriteStringA
#endif
//==============================================================================================================================================================================================================================================================
// 4.13.1.    ,  ANSI-  UNICODE-,        .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteStringAnsiToUnicodeA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                                      //                 MEMORY_TERMINAL    .
                                                                      //                 MEMORY_WINDOW      .
                                              LPCSTR    szPrefixArea, //         .
                                              const int nIndex,       //   .   ,   .
                                              LPCSTR    szName,       //   .
                                              const int nStartByte,   //      ,     .
                                              LPCSTR    szString);    //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.13.2.    ,  ANSI-  UNICODE-,        .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteStringAnsiToUnicodeW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                                      //                 MEMORY_TERMINAL    .
                                                                      //                 MEMORY_WINDOW      .
                                              LPCWSTR   szPrefixArea, //         .
                                              const int nIndex,       //   .   ,   .
                                              LPCWSTR   szName,       //   .
                                              const int nStartByte,   //      ,     .
                                              LPCSTR    szString);    //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.13.3.    ,  ANSI-  UNICODE-,        .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteStringAnsiToUnicode  MemoryWriteStringAnsiToUnicodeW
#else
 #define MemoryWriteStringAnsiToUnicode  MemoryWriteStringAnsiToUnicodeA
#endif
//==============================================================================================================================================================================================================================================================
// 4.14.1.    ,  UNICODE-  ANSI-,        .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteStringUnicodeToAnsiA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                                      //                 MEMORY_TERMINAL    .
                                                                      //                 MEMORY_WINDOW      .
                                              LPCSTR    szPrefixArea, //         .
                                              const int nIndex,       //   .   ,   .
                                              LPCSTR    szName,       //   .
                                              const int nStartByte,   //      ,     .
                                              LPCWSTR   szString);    //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.14.2.    ,  UNICODE-  ANSI-,        .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteStringUnicodeToAnsiW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                                      //                 MEMORY_TERMINAL    .
                                                                      //                 MEMORY_WINDOW      .
                                              LPCWSTR   szPrefixArea, //         .
                                              const int nIndex,       //   .   ,   .
                                              LPCWSTR   szName,       //   .
                                              const int nStartByte,   //      ,     .
                                              LPCWSTR   szString);    //      .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.14.3.    ,  UNICODE-  ANSI-,        .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteStringUnicodeToAnsi  MemoryWriteStringUnicodeToAnsiW
#else
 #define MemoryWriteStringUnicodeToAnsi  MemoryWriteStringUnicodeToAnsiA
#endif
//
// 5.             .    
//
// 5.1.1.        BOOL (1 )     .      FALSE   .    ANSI-.
EXPFUNC(bool) MemoryReadBoolA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                              LPCSTR    szPrefixArea, //         .
                              const int nIndex,       //   .   ,   .
                              LPCSTR    szName,       //   .
                              const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.1.2.        BOOL (1 )     .      FALSE   .    UNICODE-.
EXPFUNC(bool) MemoryReadBoolW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                              LPCWSTR   szPrefixArea, //         .
                              const int nIndex,       //   .   ,   .
                              LPCWSTR   szName,       //   .
                              const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadBool  MemoryReadBoolW
#else
 #define MemoryReadBool  MemoryReadBoolA
#endif
//==============================================================================================================================================================================================================================================================
// 5.2.1.        CHAR (1 )     .         .    ANSI-.
EXPFUNC(CHAR) MemoryReadCharA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                              LPCSTR    szPrefixArea, //         .
                              const int nIndex,       //   .   ,   .
                              LPCSTR    szName,       //   .
                              const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.2.2.        CHAR (1 )     .         .    UNICODE-.
EXPFUNC(CHAR) MemoryReadCharW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                              LPCWSTR   szPrefixArea, //         .
                              const int nIndex,       //   .   ,   .
                              LPCWSTR   szName,       //   .
                              const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.2.3.        CHAR (1 )     .         .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadChar  MemoryReadCharW
#else
 #define MemoryReadChar  MemoryReadCharA
#endif
//==============================================================================================================================================================================================================================================================
// 5.3.1.        UCHAR (1 )     .         .    ANSI-.
EXPFUNC(UCHAR) MemoryReadUCharA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                                LPCSTR    szPrefixArea, //         .
                                const int nIndex,       //   .   ,   .
                                LPCSTR    szName,       //   .
                                const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.3.2.        UCHAR (1 )     .         .    UNICODE-.
EXPFUNC(UCHAR) MemoryReadUCharW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                                LPCWSTR   szPrefixArea, //         .
                                const int nIndex,       //   .   ,   .
                                LPCWSTR   szName,       //   .
                                const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.3.3.        UCHAR (1 )     .         .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadUChar  MemoryReadUCharW
#else
 #define MemoryReadUChar  MemoryReadUCharA
#endif
//==============================================================================================================================================================================================================================================================
// 5.4.1.        SHORT (2 )     .         .    ANSI-.
EXPFUNC(SHORT) MemoryReadShortA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                                LPCSTR    szPrefixArea, //         .
                                const int nIndex,       //   .   ,   .
                                LPCSTR    szName,       //   .
                                const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.4.2.        SHORT (2 )     .         .    UNICODE-.
EXPFUNC(SHORT) MemoryReadShortW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                                LPCWSTR   szPrefixArea, //         .
                                const int nIndex,       //   .   ,   .
                                LPCWSTR   szName,       //   .
                                const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.4.3.        SHORT (2 )     .         .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadShort  MemoryReadShortW
#else
 #define MemoryReadShort  MemoryReadShortA
#endif
//==============================================================================================================================================================================================================================================================
// 5.5.1.        USHORT (2 )     .         .    ANSI-.
EXPFUNC(USHORT) MemoryReadUShortA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                  LPCSTR    szPrefixArea, //         .
                                  const int nIndex,       //   .   ,   .
                                  LPCSTR    szName,       //   .
                                  const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.5.2.        USHORT (2 )     .         .    UNICODE-.
EXPFUNC(USHORT) MemoryReadUShortW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                  LPCWSTR   szPrefixArea, //         .
                                  const int nIndex,       //   .   ,   .
                                  LPCWSTR   szName,       //   .
                                  const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.5.3.        USHORT (2 )     .         .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadUShort  MemoryReadUShortW
#else
 #define MemoryReadUShort  MemoryReadUShortA
#endif
//==============================================================================================================================================================================================================================================================
// 5.6.1.        INT (4 )     .         .    ANSI-.
EXPFUNC(INT) MemoryReadIntA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                            LPCSTR    szPrefixArea, //         .
                            const int nIndex,       //   .   ,   .
                            LPCSTR    szName,       //   .
                            const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.6.2.        INT (4 )     .         .    UNICODE-.
EXPFUNC(INT) MemoryReadIntW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                            LPCWSTR   szPrefixArea, //         .
                            const int nIndex,       //   .   ,   .
                            LPCWSTR   szName,       //   .
                            const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.6.3.        INT (4 )     .         .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadInt  MemoryReadIntW
#else
 #define MemoryReadInt  MemoryReadIntA
#endif
//==============================================================================================================================================================================================================================================================
// 5.7.1.        UINT (4 )     .         .    ANSI-.
EXPFUNC(UINT) MemoryReadUIntA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                              LPCSTR    szPrefixArea, //         .
                              const int nIndex,       //   .   ,   .
                              LPCSTR    szName,       //   .
                              const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.7.2.        UINT (4 )     .         .    UNICODE-.
EXPFUNC(UINT) MemoryReadUIntW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                              LPCWSTR   szPrefixArea, //         .
                              const int nIndex,       //   .   ,   .
                              LPCWSTR   szName,       //   .
                              const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.7.3.        UINT (4 )     .         .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadUInt  MemoryReadUIntW
#else
 #define MemoryReadUInt  MemoryReadUIntA
#endif
//==============================================================================================================================================================================================================================================================
// 5.8.1.        INT64 (8 )     .         .    ANSI-.
EXPFUNC(INT64) MemoryReadLongA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                       //                 MEMORY_TERMINAL    .
                                                       //                 MEMORY_WINDOW      .
                               LPCSTR    szPrefixArea, //         .
                               const int nIndex,       //   .   ,   .
                               LPCSTR    szName,       //   .
                               const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.8.2.        INT64 (8 )     .         .    UNICODE-.
EXPFUNC(INT64) MemoryReadLongW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                       //                 MEMORY_TERMINAL    .
                                                       //                 MEMORY_WINDOW      .
                               LPCWSTR   szPrefixArea, //         .
                               const int nIndex,       //   .   ,   .
                               LPCWSTR   szName,       //   .
                               const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.8.3.        INT64 (8 )     .         .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadLong  MemoryReadLongW
#else
 #define MemoryReadLong  MemoryReadLongA
#endif
//==============================================================================================================================================================================================================================================================
// 5.9.1.        UINT64 (8 )     .         .    ANSI-.
EXPFUNC(UINT64) MemoryReadULongA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                                 LPCSTR    szPrefixArea, //         .
                                 const int nIndex,       //   .   ,   .
                                 LPCSTR    szName,       //   .
                                 const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.9.2.        UINT64 (8 )     .         .    UNICODE-.
EXPFUNC(UINT64) MemoryReadULongW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                                 LPCWSTR   szPrefixArea, //         .
                                 const int nIndex,       //   .   ,   .
                                 LPCWSTR   szName,       //   .
                                 const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.9.3.        UINT64 (8 )     .         .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadULong  MemoryReadULongW
#else
 #define MemoryReadULong  MemoryReadULongA
#endif
//==============================================================================================================================================================================================================================================================
// 5.10.1.        FLOAT (4 )     .         .
EXPFUNC(FLOAT) MemoryReadFloatA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                                LPCSTR    szPrefixArea, //         .
                                const int nIndex,       //   .   ,   .
                                LPCSTR    szName,       //   .
                                const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.10.2.        FLOAT (4 )     .         .
EXPFUNC(FLOAT) MemoryReadFloatW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                        //                 MEMORY_TERMINAL    .
                                                        //                 MEMORY_WINDOW      .
                                LPCWSTR   szPrefixArea, //         .
                                const int nIndex,       //   .   ,   .
                                LPCWSTR   szName,       //   .
                                const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.10.3.        FLOAT (4 )     .         .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadFloat  MemoryReadFloatW
#else
 #define MemoryReadFloat  MemoryReadFloatA
#endif
//==============================================================================================================================================================================================================================================================
// 5.11.1.        DOUBLE (8 )     .         .    ANSI-.
EXPFUNC(double) MemoryReadDoubleA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                  LPCSTR    szPrefixArea, //         .
                                  const int nIndex,       //   .   ,   .
                                  LPCSTR    szName,       //   .
                                  const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.11.2.        DOUBLE (8 )     .         .    UNICODE-.
EXPFUNC(double) MemoryReadDoubleW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                  LPCWSTR   szPrefixArea, //         .
                                  const int nIndex,       //   .   ,   .
                                  LPCWSTR   szName,       //   .
                                  const int nStartByte);  //      ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.11.3.        DOUBLE (8 )     .         .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadDouble  MemoryReadDoubleW
#else
 #define MemoryReadDouble  MemoryReadDoubleA
#endif
//==============================================================================================================================================================================================================================================================
// 5.12.1.      ANSI-           .      NULL.    ANSI-.
EXPFUNC(LPSTR) MemoryReadStringA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                                 LPCSTR    szPrefixArea, //         .
                                 const int nIndex,       //   .   ,   .
                                 LPCSTR    szName,       //   .
                                 const int nStartByte,   //      ,     .
                                 const int nLength);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.12.2.      UNICODE-           .      NULL.    UNICODE-.
EXPFUNC(LPWSTR) MemoryReadStringW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                  LPCWSTR   szPrefixArea, //         .
                                  const int nIndex,       //   .   ,   .
                                  LPCWSTR   szName,       //   .
                                  const int nStartByte,   //      ,     .
                                  const int nLength);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.12.3.                   .      NULL.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadString  MemoryReadStringW
#else
 #define MemoryReadString  MemoryReadStringA
#endif
//==============================================================================================================================================================================================================================================================
// 5.13.1.      ANSI-     ,    UNICODE-      UNICODE-.
//              NULL.    ANSI-.
EXPFUNC(LPWSTR) MemoryReadStringAnsiToUnicodeA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                                       //                 MEMORY_TERMINAL    .
                                                                       //                 MEMORY_WINDOW      .
                                               LPCSTR    szPrefixArea, //         .
                                               const int nIndex,       //   .   ,   .
                                               LPCSTR    szName,       //   .
                                               const int nStartByte,   //      ,     .
                                               const int nLength);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.13.2.      ANSI-     ,    UNICODE-      UNICODE-.
//              NULL.    UNICODE-.
EXPFUNC(LPWSTR) MemoryReadStringAnsiToUnicodeW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                                       //                 MEMORY_TERMINAL    .
                                                                       //                 MEMORY_WINDOW      .
                                               LPCWSTR   szPrefixArea, //         .
                                               const int nIndex,       //   .   ,   .
                                               LPCWSTR   szName,       //   .
                                               const int nStartByte,   //      ,     .
                                               const int nLength);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.13.3.      ANSI-     ,    UNICODE-      UNICODE-.
//              NULL.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadStringAnsiToUnicode  MemoryReadStringAnsiToUnicodeW
#else
 #define MemoryReadStringAnsiToUnicode  MemoryReadStringAnsiToUnicodeA
#endif
//==============================================================================================================================================================================================================================================================
// 5.14.1.      UNICODE-     ,    ANSI-      ANSI-.
//              NULL.    ANSI-.
EXPFUNC(LPSTR) MemoryReadStringUnicodeToAnsiA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                                      //                 MEMORY_TERMINAL    .
                                                                      //                 MEMORY_WINDOW      .
                                              LPCSTR    szPrefixArea, //         .
                                              const int nIndex,       //   .   ,   .
                                              LPCSTR    szName,       //   .
                                              const int nStartByte,   //      ,     .
                                              const int nLength);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.14.2.      UNICODE-     ,    ANSI-      ANSI-.
//              NULL.    UNICODE-.
EXPFUNC(LPSTR) MemoryReadStringUnicodeToAnsiW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                                      //                 MEMORY_TERMINAL    .
                                                                      //                 MEMORY_WINDOW      .
                                              LPCWSTR   szPrefixArea, //         .
                                              const int nIndex,       //   .   ,   .
                                              LPCWSTR   szName,       //   .
                                              const int nStartByte,   //      ,     .
                                              const int nLength);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.14.3.      UNICODE-     ,    ANSI-      ANSI-.
//              NULL.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadStringUnicodeToAnsi  MemoryReadStringUnicodeToAnsiW
#else
 #define MemoryReadStringUnicodeToAnsi  MemoryReadStringUnicodeToAnsiA
#endif
//
// 6.           .    
//
// 6.1.1.             BOOL (1 )     .
//          TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteBoolArrayA(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                    LPCSTR      szPrefixArea, //         .
                                    const int   nIndex,       //   .   ,   .
                                    LPCSTR      szName,       //   .
                                    const int   nStartByte,   //      ,     .
                                    const bool* abArray,      //        BOOL     .
                                    const int   nSizeArray,   //   (  ).
                                    const int   nStart,       //     (   ).
                                    const int   nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.1.2.             BOOL     .
//          TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteBoolArrayW(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                    LPCWSTR     szPrefixArea, //         .
                                    const int   nIndex,       //   .   ,   .
                                    LPCWSTR     szName,       //   .
                                    const int   nStartByte,   //      ,     .
                                    const bool* abArray,      //        BOOL     .
                                    const int   nSizeArray,   //   (  ).
                                    const int   nStart,       //     (   ).
                                    const int   nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.1.3.             BOOL     .
//          TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteBoolArray  MemoryWriteBoolArrayW
#else
 #define MemoryWriteBoolArray  MemoryWriteBoolArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 6.2.1.             CHAR (1 )     .
//          TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteCharArrayA(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                    LPCSTR      szPrefixArea, //         .
                                    const int   nIndex,       //   .   ,   .
                                    LPCSTR      szName,       //   .
                                    const int   nStartByte,   //      ,     .
                                    const PCHAR acArray,      //       CHAR (1 )     .
                                    const int   nSizeArray,   //   (  ).
                                    const int   nStart,       //     (   ).
                                    const int   nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.2.2.             CHAR (1 )     .
//          TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteCharArrayW(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                    LPCWSTR     szPrefixArea, //         .
                                    const int   nIndex,       //   .   ,   .
                                    LPCWSTR     szName,       //   .
                                    const int   nStartByte,   //      ,     .
                                    const PCHAR acArray,      //       CHAR (1 )     .
                                    const int   nSizeArray,   //   (  ).
                                    const int   nStart,       //     (   ).
                                    const int   nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.2.3.             CHAR (1 )     .
//          TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteCharArray  MemoryWriteCharArrayW
#else
 #define MemoryWriteCharArray  MemoryWriteCharArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 6.3.1.             UCHAR (1 )     .
//          TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteUCharArrayA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                                //                 MEMORY_TERMINAL    .
                                                                //                 MEMORY_WINDOW      .
                                     LPCSTR       szPrefixArea, //         .
                                     const int    nIndex,       //   .   ,   .
                                     LPCSTR       szName,       //   .
                                     const int    nStartByte,   //      ,     .
                                     const PUCHAR aucArray,     //       UCHAR (1 )     .
                                     const int    nSizeArray,   //   (  ).
                                     const int    nStart,       //     (   ).
                                     const int    nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.3.2.             UCHAR (1 )     .
//          TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteUCharArrayW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                                //                 MEMORY_TERMINAL    .
                                                                //                 MEMORY_WINDOW      .
                                     LPCWSTR      szPrefixArea, //         .
                                     const int    nIndex,       //   .   ,   .
                                     LPCWSTR      szName,       //   .
                                     const int    nStartByte,   //      ,     .
                                     const PUCHAR aucArray,     //       UCHAR (1 )     .
                                     const int    nSizeArray,   //   (  ).
                                     const int    nStart,       //     (   ).
                                     const int    nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.3.3.             UCHAR (1 )     .
//          TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteUCharArray  MemoryWriteUCharArrayW
#else
 #define MemoryWriteUCharArray  MemoryWriteUCharArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 6.4.1.             SHORT (2 )     .
//          TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteShortArrayA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                                //                 MEMORY_TERMINAL    .
                                                                //                 MEMORY_WINDOW      .
                                     LPCSTR       szPrefixArea, //         .
                                     const int    nIndex,       //   .   ,   .
                                     LPCSTR       szName,       //   .
                                     const int    nStartByte,   //      ,     .
                                     const PSHORT ashArray,     //       SHORT (2 )     .
                                     const int    nSizeArray,   //   (  ).
                                     const int    nStart,       //     (   ).
                                     const int    nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.4.2.             SHORT (2 )     .
//          TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteShortArrayW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                                //                 MEMORY_TERMINAL    .
                                                                //                 MEMORY_WINDOW      .
                                     LPCWSTR      szPrefixArea, //         .
                                     const int    nIndex,       //   .   ,   .
                                     LPCWSTR      szName,       //   .
                                     const int    nStartByte,   //      ,     .
                                     const PSHORT ashArray,     //       SHORT (2 )     .
                                     const int    nSizeArray,   //   (  ).
                                     const int    nStart,       //     (   ).
                                     const int    nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.4.3.             SHORT (2 )     .
//          TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteShortArray  MemoryWriteShortArrayW
#else
 #define MemoryWriteShortArray  MemoryWriteShortArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 6.5.1.             USHORT (2 )     .
//          TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteUShortArrayA(const int     nArea,        //  : MEMORY_GLOBAL      .
                                                                  //                 MEMORY_TERMINAL    .
                                                                  //                 MEMORY_WINDOW      .
                                      LPCSTR        szPrefixArea, //         .
                                      const int     nIndex,       //   .   ,   .
                                      LPCSTR        szName,       //   .
                                      const int     nStartByte,   //      ,     .
                                      const PUSHORT aushArray,    //       USHORT (2 )     .
                                      const int     nSizeArray,   //   (  ).
                                      const int     nStart,       //     (   ).
                                      const int     nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.5.2.             USHORT (2 )     .
//          TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteUShortArrayW(const int     nArea,        //  : MEMORY_GLOBAL      .
                                                                  //                 MEMORY_TERMINAL    .
                                                                  //                 MEMORY_WINDOW      .
                                      LPCWSTR       szPrefixArea, //         .
                                      const int     nIndex,       //   .   ,   .
                                      LPCWSTR       szName,       //   .
                                      const int     nStartByte,   //      ,     .
                                      const PUSHORT aushArray,    //       USHORT (2 )     .
                                      const int     nSizeArray,   //   (  ).
                                      const int     nStart,       //     (   ).
                                      const int     nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.5.3.             USHORT (2 )     .
//          TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteUShortArray  MemoryWriteUShortArrayW
#else
 #define MemoryWriteUShortArray  MemoryWriteUShortArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 6.6.1.             INT (4 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteIntArrayA(const int  nArea,        //  : MEMORY_GLOBAL      .
                                                            //                 MEMORY_TERMINAL    .
                                                            //                 MEMORY_WINDOW      .
                                   LPCSTR     szPrefixArea, //         .
                                   const int  nIndex,       //   .   ,   .
                                   LPCSTR     szName,       //   .
                                   const int  nStartByte,   //      ,     .
                                   const PINT aiArray,      //       INT (4 )     .
                                   const int  nSizeArray,   //   (  ).
                                   const int  nStart,       //     (   ).
                                   const int  nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.6.2.             INT (4 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteIntArrayW(const int  nArea,        //  : MEMORY_GLOBAL      .
                                                            //                 MEMORY_TERMINAL    .
                                                            //                 MEMORY_WINDOW      .
                                   LPCWSTR    szPrefixArea, //         .
                                   const int  nIndex,       //   .   ,   .
                                   LPCWSTR    szName,       //   .
                                   const int  nStartByte,   //      ,     .
                                   const PINT aiArray,      //       INT (4 )     .
                                   const int  nSizeArray,   //   (  ).
                                   const int  nStart,       //     (   ).
                                   const int  nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.6.3.             INT (4 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteIntArray  MemoryWriteIntArrayW
#else
 #define MemoryWriteIntArray  MemoryWriteIntArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 6.7.1.             UINT (4 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteUIntArrayA(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                    LPCSTR      szPrefixArea, //         .
                                    const int   nIndex,       //   .   ,   .
                                    LPCSTR      szName,       //   .
                                    const int   nStartByte,   //      ,     .
                                    const PUINT auiArray,     //       UINT (4 )     .
                                    const int   nSizeArray,   //   (  ).
                                    const int   nStart,       //     (   ).
                                    const int   nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.7.2.             UINT (4 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteUIntArrayW(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                    LPCWSTR     szPrefixArea, //         .
                                    const int   nIndex,       //   .   ,   .
                                    LPCWSTR     szName,       //   .
                                    const int   nStartByte,   //      ,     .
                                    const PUINT auiArray,     //       UINT (4 )     .
                                    const int   nSizeArray,   //   (  ).
                                    const int   nStart,       //     (   ).
                                    const int   nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.7.3.             UINT (4 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteUIntArray  MemoryWriteUIntArrayW
#else
 #define MemoryWriteUIntArray  MemoryWriteUIntArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 6.8.1.             INT64 (8 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteLongArrayA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                               //                 MEMORY_TERMINAL    .
                                                               //                 MEMORY_WINDOW      .
                                    LPCSTR       szPrefixArea, //         .
                                    const int    nIndex,       //   .   ,   .
                                    LPCSTR       szName,       //   .
                                    const int    nStartByte,   //      ,     .
                                    const PINT64 ai64Array,    //       INT64 (8 )     .
                                    const int    nSizeArray,   //   (  ).
                                    const int    nStart,       //     (   ).
                                    const int    nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.8.2.             INT64 (8 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteLongArrayW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                               //                 MEMORY_TERMINAL    .
                                                               //                 MEMORY_WINDOW      .
                                    LPCWSTR      szPrefixArea, //         .
                                    const int    nIndex,       //   .   ,   .
                                    LPCWSTR      szName,       //   .
                                    const int    nStartByte,   //      ,     .
                                    const PINT64 ai64Array,    //       INT64 (8 )     .
                                    const int    nSizeArray,   //   (  ).
                                    const int    nStart,       //     (   ).
                                    const int    nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.8.3.             INT64 (8 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteLongArray  MemoryWriteLongArrayW
#else
 #define MemoryWriteLongArray  MemoryWriteLongArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 6.9.1.             UINT64 (8 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteULongArrayA(const int     nArea,        //  : MEMORY_GLOBAL      .
                                                                 //                 MEMORY_TERMINAL    .
                                                                 //                 MEMORY_WINDOW      .
                                     LPCSTR        szPrefixArea, //         .
                                     const int     nIndex,       //   .   ,   .
                                     LPCSTR        szName,       //   .
                                     const int     nStartByte,   //      ,     .
                                     const PUINT64 aui64Array,   //       UINT64 (8 )     .
                                     const int     nSizeArray,   //   (  ).
                                     const int     nStart,       //     (   ).
                                     const int     nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.9.2.             INT64 (8 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteULongArrayW(const int     nArea,        //  : MEMORY_GLOBAL      .
                                                                 //                 MEMORY_TERMINAL    .
                                                                 //                 MEMORY_WINDOW      .
                                     LPCWSTR       szPrefixArea, //         .
                                     const int     nIndex,       //   .   ,   .
                                     LPCWSTR       szName,       //   .
                                     const int     nStartByte,   //      ,     .
                                     const PUINT64 aui64Array,   //       UINT64 (8 )     .
                                     const int     nSizeArray,   //   (  ).
                                     const int     nStart,       //     (   ).
                                     const int     nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.9.3.             UINT64 (8 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteULongArray  MemoryWriteULongArrayW
#else
 #define MemoryWriteULongArray  MemoryWriteULongArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 6.10.1.             FLOAT (4 )     .
//           TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteFloatArrayA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                                //                 MEMORY_TERMINAL    .
                                                                //                 MEMORY_WINDOW      .
                                     LPCSTR       szPrefixArea, //         .
                                     const int    nIndex,       //   .   ,   .
                                     LPCSTR       szName,       //   .
                                     const int    nStartByte,   //      ,     .
                                     const PFLOAT afArray,      //       FLOAT (4 )     .
                                     const int    nSizeArray,   //   (  ).
                                     const int    nStart,       //     (   ).
                                     const int    nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.10.2.             FLOAT (4 )     .
//           TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteFloatArrayW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                                //                 MEMORY_TERMINAL    .
                                                                //                 MEMORY_WINDOW      .
                                     LPCWSTR      szPrefixArea, //         .
                                     const int    nIndex,       //   .   ,   .
                                     LPCWSTR      szName,       //   .
                                     const int    nStartByte,   //      ,     .
                                     const PFLOAT afArray,      //       FLOAT (4 )     .
                                     const int    nSizeArray,   //   (  ).
                                     const int    nStart,       //     (   ).
                                     const int    nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.10.3.             FLOAT (4 )     .
//           TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteFloatArray  MemoryWriteFloatArrayW
#else
 #define MemoryWriteFloatArray  MemoryWriteFloatArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 6.11.1.             DOUBLE (8 )     .    ,   .
//           TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryWriteDoubleArrayA(const int nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                      LPCSTR    szPrefixArea, //         .
                                      const int nIndex,       //   .   ,   .
                                      LPCSTR    szName,       //   .
                                      const int nStartByte,   //      ,     .
                                      PCDOUBLE  adArray,      //       DOUBLE (8 )     .
                                      const int nSizeArray,   //   (  ).
                                      const int nStart,       //     (   ).
                                      const int nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.11.2.             DOUBLE (8 )     .    ,   .
//           TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryWriteDoubleArrayW(const int nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                      LPCWSTR   szPrefixArea, //         .
                                      const int nIndex,       //   .   ,   .
                                      LPCWSTR   szName,       //   .
                                      const int nStartByte,   //      ,     .
                                      PCDOUBLE  adArray,      //       DOUBLE (8 )     .
                                      const int nSizeArray,   //   (  ).
                                      const int nStart,       //     (   ).
                                      const int nCount);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.11.3.             DOUBLE (8 )     .    ,   .
//           TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryWriteDoubleArray  MemoryWriteDoubleArrayW
#else
 #define MemoryWriteDoubleArray  MemoryWriteDoubleArrayA
#endif
//
// 7.           .    
//
// 7.1.1.        BOOL (1 )    BOOL (1 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryReadBoolArrayA(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                             //                 MEMORY_TERMINAL    .
                                                             //                 MEMORY_WINDOW      .
                                   LPCSTR      szPrefixArea, //         .
                                   const int   nIndex,       //   .   ,   .
                                   LPCSTR      szName,       //   .
                                   const int   nStartByte,   //      ,      .
                                         bool* abArray,      //           BOOL   .
                                   const int   nSizeArray,   //   (  ).
                                   const int   nStart,       //       (   ).
                                   const int   nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.1.2.        BOOL (1 )    BOOL (1 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryReadBoolArrayW(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                             //                 MEMORY_TERMINAL    .
                                                             //                 MEMORY_WINDOW      .
                                   LPCWSTR     szPrefixArea, //         .
                                   const int   nIndex,       //   .   ,   .
                                   LPCWSTR     szName,       //   .
                                   const int   nStartByte,   //      ,      .
                                         bool* abArray,      //           BOOL   .
                                   const int   nSizeArray,   //   (  ).
                                   const int   nStart,       //       (   ).
                                   const int   nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.1.3.        BOOL (1 )    BOOL (1 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadBoolArray  MemoryReadBoolArrayW
#else
 #define MemoryReadBoolArray  MemoryReadBoolArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 7.2.1.        CHAR (1 )    CHAR (1 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryReadCharArrayA(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                             //                 MEMORY_TERMINAL    .
                                                             //                 MEMORY_WINDOW      .
                                   LPCSTR      szPrefixArea, //         .
                                   const int   nIndex,       //   .   ,   .
                                   LPCSTR      szName,       //   .
                                   const int   nStartByte,   //      ,      .
                                         PCHAR acArray,      //          CHAR (1 )   .
                                   const int   nSizeArray,   //   (  ).
                                   const int   nStart,       //       (   ).
                                   const int   nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.2.2.        CHAR (1 )    CHAR (1 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryReadCharArrayW(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                             //                 MEMORY_TERMINAL    .
                                                             //                 MEMORY_WINDOW      .
                                   LPCWSTR     szPrefixArea, //         .
                                   const int   nIndex,       //   .   ,   .
                                   LPCWSTR     szName,       //   .
                                   const int   nStartByte,   //      ,      .
                                         PCHAR acArray,      //          CHAR (1 )   .
                                   const int   nSizeArray,   //   (  ).
                                   const int   nStart,       //       (   ).
                                   const int   nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.2.3.        CHAR (1 )    CHAR (1 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadCharArray  MemoryReadCharArrayW
#else
 #define MemoryReadCharArray  MemoryReadCharArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 7.3.1.        UCHAR (1 )    UCHAR (1 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryReadUCharArrayA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                               //                 MEMORY_TERMINAL    .
                                                               //                 MEMORY_WINDOW      .
                                    LPCSTR       szPrefixArea, //         .
                                    const int    nIndex,       //   .   ,   .
                                    LPCSTR       szName,       //   .
                                    const int    nStartByte,   //      ,      .
                                          PUCHAR aucArray,     //          UCHAR (1 )   .
                                    const int    nSizeArray,   //   (  ).
                                    const int    nStart,       //       (   ).
                                    const int    nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.3.2.        UCHAR (1 )    UCHAR (1 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryReadUCharArrayW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                               //                 MEMORY_TERMINAL    .
                                                               //                 MEMORY_WINDOW      .
                                    LPCWSTR      szPrefixArea, //         .
                                    const int    nIndex,       //   .   ,   .
                                    LPCWSTR      szName,       //   .
                                    const int    nStartByte,   //      ,      .
                                          PUCHAR aucArray,     //          UCHAR (1 )   .
                                    const int    nSizeArray,   //   (  ).
                                    const int    nStart,       //       (   ).
                                    const int    nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.3.3.        UCHAR (1 )    UCHAR (1 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadUCharArray  MemoryReadUCharArrayW
#else
 #define MemoryReadUCharArray  MemoryReadUCharArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 7.4.1.        SHORT (2 )    SHORT (2 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryReadShortArrayA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                               //                 MEMORY_TERMINAL    .
                                                               //                 MEMORY_WINDOW      .
                                    LPCSTR       szPrefixArea, //         .
                                    const int    nIndex,       //   .   ,   .
                                    LPCSTR       szName,       //   .
                                    const int    nStartByte,   //      ,      .
                                          PSHORT ashArray,     //          SHORT (2 )   .
                                    const int    nSizeArray,   //   (  ).
                                    const int    nStart,       //       (   ).
                                    const int    nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.4.2.        SHORT (2 )    SHORT (2 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryReadShortArrayW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                               //                 MEMORY_TERMINAL    .
                                                               //                 MEMORY_WINDOW      .
                                    LPCWSTR      szPrefixArea, //         .
                                    const int    nIndex,       //   .   ,   .
                                    LPCWSTR      szName,       //   .
                                    const int    nStartByte,   //      ,      .
                                          PSHORT ashArray,     //          SHORT (2 )   .
                                    const int    nSizeArray,   //   (  ).
                                    const int    nStart,       //       (   ).
                                    const int    nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.4.3.        SHORT (2 )    SHORT (2 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadShortArray  MemoryReadShortArrayW
#else
 #define MemoryReadShortArray  MemoryReadShortArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 7.5.1.        USHORT (2 )    USHORT (2 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryReadUShortArrayA(const int     nArea,        //  : MEMORY_GLOBAL      .
                                                                 //                 MEMORY_TERMINAL    .
                                                                 //                 MEMORY_WINDOW      .
                                     LPCSTR        szPrefixArea, //         .
                                     const int     nIndex,       //   .   ,   .
                                     LPCSTR        szName,       //   .
                                     const int     nStartByte,   //      ,      .
                                           PUSHORT aushArray,    //          USHORT (2 )   .
                                     const int     nSizeArray,   //   (  ).
                                     const int     nStart,       //       (   ).
                                     const int     nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.5.2.        USHORT (2 )    USHORT (2 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryReadUShortArrayW(const int     nArea,        //  : MEMORY_GLOBAL      .
                                                                 //                 MEMORY_TERMINAL    .
                                                                 //                 MEMORY_WINDOW      .
                                     LPCWSTR       szPrefixArea, //         .
                                     const int     nIndex,       //   .   ,   .
                                     LPCWSTR       szName,       //   .
                                     const int     nStartByte,   //      ,      .
                                           PUSHORT aushArray,    //          USHORT (2 )   .
                                     const int     nSizeArray,   //   (  ).
                                     const int     nStart,       //       (   ).
                                     const int     nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.5.3.        USHORT (2 )    USHORT (2 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadUShortArray  MemoryReadUShortArrayW
#else
 #define MemoryReadUShortArray  MemoryReadUShortArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 7.6.1.        INT (4 )    INT (4 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryReadIntArrayA(const int  nArea,        //  : MEMORY_GLOBAL      .
                                                           //                 MEMORY_TERMINAL    .
                                                           //                 MEMORY_WINDOW      .
                                  LPCSTR     szPrefixArea, //         .
                                  const int  nIndex,       //   .   ,   .
                                  LPCSTR     szName,       //   .
                                  const int  nStartByte,   //      ,      .
                                        PINT aiArray,      //          INT (4 )   .
                                  const int  nSizeArray,   //   (  ).
                                  const int  nStart,       //       (   ).
                                  const int  nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.6.2.        INT (4 )    INT (4 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryReadIntArrayW(const int  nArea,        //  : MEMORY_GLOBAL      .
                                                           //                 MEMORY_TERMINAL    .
                                                           //                 MEMORY_WINDOW      .
                                  LPCWSTR    szPrefixArea, //         .
                                  const int  nIndex,       //   .   ,   .
                                  LPCWSTR    szName,       //   .
                                  const int  nStartByte,   //      ,      .
                                        PINT aiArray,      //          INT (4 )   .
                                  const int  nSizeArray,   //   (  ).
                                  const int  nStart,       //       (   ).
                                  const int  nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.6.3.        INT (4 )    INT (4 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadIntArray  MemoryReadIntArrayW
#else
 #define MemoryReadIntArray  MemoryReadIntArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 7.7.1.        UINT (4 )    UINT (4 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryReadUIntArrayA(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                             //                 MEMORY_TERMINAL    .
                                                             //                 MEMORY_WINDOW      .
                                   LPCSTR      szPrefixArea, //         .
                                   const int   nIndex,       //   .   ,   .
                                   LPCSTR      szName,       //   .
                                   const int   nStartByte,   //      ,      .
                                         PUINT auiArray,     //          UINT (4 )   .
                                   const int   nSizeArray,   //   (  ).
                                   const int   nStart,       //       (   ).
                                   const int   nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.7.2.        UINT (4 )    UINT (4 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryReadUIntArrayW(const int   nArea,        //  : MEMORY_GLOBAL      .
                                                             //                 MEMORY_TERMINAL    .
                                                             //                 MEMORY_WINDOW      .
                                   LPCWSTR     szPrefixArea, //         .
                                   const int   nIndex,       //   .   ,   .
                                   LPCWSTR     szName,       //   .
                                   const int   nStartByte,   //      ,      .
                                         PUINT auiArray,     //          UINT (4 )   .
                                   const int   nSizeArray,   //   (  ).
                                   const int   nStart,       //       (   ).
                                   const int   nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.7.3.        UINT (4 )    UINT (4 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadUIntArray  MemoryReadUIntArrayW
#else
 #define MemoryReadUIntArray  MemoryReadUIntArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 7.8.1.        INT64 (8 )    INT64 (8 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryReadLongArrayA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                   LPCSTR       szPrefixArea, //         .
                                   const int    nIndex,       //   .   ,   .
                                   LPCSTR       szName,       //   .
                                   const int    nStartByte,   //      ,      .
                                         PINT64 ai64Array,    //          INT64 (8 )   .
                                   const int    nSizeArray,   //   (  ).
                                   const int    nStart,       //       (   ).
                                   const int    nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.8.2.        INT64 (8 )    INT64 (8 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryReadLongArrayW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                   LPCWSTR      szPrefixArea, //         .
                                   const int    nIndex,       //   .   ,   .
                                   LPCWSTR      szName,       //   .
                                   const int    nStartByte,   //      ,      .
                                         PINT64 ai64Array,    //          INT64 (8 )   .
                                   const int    nSizeArray,   //   (  ).
                                   const int    nStart,       //       (   ).
                                   const int    nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.8.3.        INT64 (8 )    INT64 (8 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadLongArray  MemoryReadLongArrayW
#else
 #define MemoryReadLongArray  MemoryReadLongArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 7.9.1.        UINT64 (8 )    UINT64 (8 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryReadULongArrayA(const int     nArea,        //  : MEMORY_GLOBAL      .
                                                                //                 MEMORY_TERMINAL    .
                                                                //                 MEMORY_WINDOW      .
                                    LPCSTR        szPrefixArea, //         .
                                    const int     nIndex,       //   .   ,   .
                                    LPCSTR        szName,       //   .
                                    const int     nStartByte,   //      ,      .
                                          PUINT64 aui64Array,   //          UINT64 (8 )   .
                                    const int     nSizeArray,   //   (  ).
                                    const int     nStart,       //       (   ).
                                    const int     nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.9.2.        UINT64 (8 )    UINT64 (8 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryReadULongArrayW(const int     nArea,        //  : MEMORY_GLOBAL      .
                                                                //                 MEMORY_TERMINAL    .
                                                                //                 MEMORY_WINDOW      .
                                    LPCWSTR       szPrefixArea, //         .
                                    const int     nIndex,       //   .   ,   .
                                    LPCWSTR       szName,       //   .
                                    const int     nStartByte,   //      ,      .
                                          PUINT64 aui64Array,   //          UINT64 (8 )   .
                                    const int     nSizeArray,   //   (  ).
                                    const int     nStart,       //       (   ).
                                    const int     nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.9.3.        UINT64 (8 )    UINT64 (8 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadULongArray  MemoryReadULongArrayW
#else
 #define MemoryReadULongArray  MemoryReadULongArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 7.10.1.        FLOAT (4 )    FLOAT (4 )     .     FLOAT (4 )     DOUBLE (8 )    .
//           TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryReadFloatArrayA(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                               //                 MEMORY_TERMINAL    .
                                                               //                 MEMORY_WINDOW      .
                                    LPCSTR       szPrefixArea, //         .
                                    const int    nIndex,       //   .   ,   .
                                    LPCSTR       szName,       //   .
                                    const int    nStartByte,   //      ,      .
                                          PFLOAT afArray,      //          FLOAT (4 )   .
                                    const int    nSizeArray,   //   (  ).
                                    const int    nStart,       //       (   ).
                                    const int    nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.10.2.        FLOAT (4 )    FLOAT (4 )     .     FLOAT (4 )     DOUBLE (8 )    .
//           TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryReadFloatArrayW(const int    nArea,        //  : MEMORY_GLOBAL      .
                                                               //                 MEMORY_TERMINAL    .
                                                               //                 MEMORY_WINDOW      .
                                    LPCWSTR      szPrefixArea, //         .
                                    const int    nIndex,       //   .   ,   .
                                    LPCWSTR      szName,       //   .
                                    const int    nStartByte,   //      ,      .
                                          PFLOAT afArray,      //          FLOAT (4 )   .
                                    const int    nSizeArray,   //   (  ).
                                    const int    nStart,       //       (   ).
                                    const int    nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.10.3.        FLOAT (4 )    FLOAT (4 )     .     FLOAT (4 )     DOUBLE (8 )    .
//          TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadFloatArray  MemoryReadFloatArrayW
#else
 #define MemoryReadFloatArray  MemoryReadFloatArrayA
#endif
//==============================================================================================================================================================================================================================================================
// 7.11.1.        DOUBLE (8 )    DOUBLE (8 )     .   TRUE     - FALSE.    ANSI-.
EXPFUNC(BOOL) MemoryReadDoubleArrayA(const int     nArea,        //  : MEMORY_GLOBAL      .
                                                                 //                 MEMORY_TERMINAL    .
                                                                 //                 MEMORY_WINDOW      .
                                     LPCSTR        szPrefixArea, //         .
                                     const int     nIndex,       //   .   ,   .
                                     LPCSTR        szName,       //   .
                                     const int     nStartByte,   //      ,      .
                                           PDOUBLE adArray,      //          DOUBLE (8 )   .
                                     const int     nSizeArray,   //   (  ).
                                     const int     nStart,       //       (   ).
                                     const int     nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.11.2.        DOUBLE (8 )    DOUBLE (8 )     .   TRUE     - FALSE.    UNICODE-.
EXPFUNC(BOOL) MemoryReadDoubleArrayW(const int     nArea,        //  : MEMORY_GLOBAL      .
                                                                 //                 MEMORY_TERMINAL    .
                                                                 //                 MEMORY_WINDOW      .
                                     LPCWSTR       szPrefixArea, //         .
                                     const int     nIndex,       //   .   ,   .
                                     LPCWSTR       szName,       //   .
                                     const int     nStartByte,   //      ,      .
                                           PDOUBLE adArray,      //          DOUBLE (8 )   .
                                     const int     nSizeArray,   //   (  ).
                                     const int     nStart,       //       (   ).
                                     const int     nCount);      //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.11.3.        DOUBLE (8 )    DOUBLE (8 )     .   TRUE     - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define MemoryReadDoubleArray  MemoryReadDoubleArrayW
#else
 #define MemoryReadDoubleArray  MemoryReadDoubleArrayA
#endif
//