//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                                                   SharedMemory.mqh   |
//|                                                                                                                                                   Copyright  Zhunko |
//|30.03.2010 - 07.02.2014                                                                                                                            vadim@zhunko.ru    |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|             .         (      |
//|)    .                  |
//|,          .               |
//| .             .            |
//|,      .            . ,  |
//|   .                                                                                                                                |
//|            .    -1,      ,   |
//|,     .        ,            |
//|.       .                                                                                                            |
//|   , ,   ,     ,    .    "MemoryCreateProjection()"        |
//|"MemoryOpenProjection()"             .    /     |
//|      .  ,      ,   .                                                   |
//|    "MemoryCreate()"   "MemoryOpen()"       ,            |
//|       "MemoryCloseHandle()".                       |
//|  .      "MemoryProjection()"               |
//| .                                                                                                                                                 |
//|         .     /            |
//| .                                                                                                                                                   |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|    :                                                                                                                                         |
//| 1.  .       .                                                                                      |
//| 2.     .         .                                                    |
//| 3.      .          .                                          |
//|           (    ) :     |
//| -    25;                                                                                                                                        |
//| -       50;                                                                                                                       |
//| -        100.                                                                                                                 |
//|    "MemoryInit()"       .     5240         |
//|5764   -  .                                                                                                           |
//|                                                                                                                                                                      |
//|         (    ) :                |
//| -    1;                                                                                                                                         |
//| -       1;                                                                                                                        |
//| -        1.                                                                                                                   |
//|  ,           ,        .    |
//|        ,       .        .                     |
//|  ,    .                                                                                                                                  |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//| 146    7 .                                                                                                                                    |
//| 1.   .                                                                                                                                 |
//| 2.  .                                                                                                                                                    |
//| 3.              .                                           |
//| 4.         .                                                                                                                |
//| 5.         .                                                                                                               |
//| 6.       .                                                                                                                     |
//| 7.       .                                                                                                                    |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//

#ifndef size_t
 #ifdef  TERMINAL_X64
  #define size_t       ulong
 #else
  #define size_t       uint
 #endif
#endif

#ifndef BOOL
 #define BOOL          int
#endif

//        "SharedMemory.dll". 
#define MEMORY_GLOBAL         0 //   .
#define MEMORY_TERMINAL       1 //   .
#define MEMORY_WINDOW         2 //   .

//
#import "SharedMemory.dll"
 //
 // 1.       .    
 //
 // 1.1.            .
 //         . ,      
 //      (   )    .      .
 void MemoryInit(int nUserClassesGlobal,   //        .
                 int nUserClassesTerminal, //        .
                 int nUserClassesWindow);  //        .
 //=======================================================================================================================================================================
 // 1.2.           .  ,   .
 void MemoryInitDebug(int nProcessID); //    4.    - .
 //
 // 2.      .    
 //
 // 2.1.1.      .      -1.    ANSI-.
 int MemoryActiveA(int    nArea,           //  : MEMORY_GLOBAL      .
                                           //                 MEMORY_TERMINAL    .
                                           //                 MEMORY_WINDOW      .
                   uchar &szPrefixArea[]); //         .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.2.      .      -1.    UNICODE-.
 int MemoryActiveW(int    nArea,        //  : MEMORY_GLOBAL      .
                                        //                 MEMORY_TERMINAL    .
                                        //                 MEMORY_WINDOW      .
                   string sPrefixArea); //         .
 //=======================================================================================================================================================================
 // 2.2.1.             .
 //                .
 //                     .
 //                         .
 //          "nIndex"  -1,     ,    .      NULL.
 //           ANSI-.
 int MemoryCreateA(int    nArea,          //  : MEMORY_GLOBAL      .
                                          //                 MEMORY_TERMINAL    .
                                          //                 MEMORY_WINDOW      .
                   uchar &szPrefixArea[], //         .
                   int    hFileUser,      //    .
                   int    nIndex,         //   .   ,   .
                   uchar &szName[],       //   .
                   int    nSize);         //      .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.2.2.             .
 //                .
 //                     .
 //                         .
 //          "nIndex"  -1,     ,    .      NULL.
 //           UNICODE-.
 int MemoryCreateW(int    nArea,       //  : MEMORY_GLOBAL      .
                                       //                 MEMORY_TERMINAL    .
                                       //                 MEMORY_WINDOW      .
                   string sPrefixArea, //         .
                   int    hFileUser,   //    .
                   int    nIndex,      //   .   ,   .
                   string sName,       //   .
                   int    nSize);      //      .
 //=======================================================================================================================================================================
 // 2.3.1.    TRUE,       ,   FALSE.    ANSI-.
 BOOL MemoryCheckIndexA(int    nArea,          //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                        uchar &szPrefixArea[], //         .
                        int    nIndex);        //   .   ,   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.3.2.    TRUE,       ,   FALSE.    UNICODE-.
 BOOL MemoryCheckIndexW(int    nArea,       //  : MEMORY_GLOBAL      .
                                            //                 MEMORY_TERMINAL    .
                                            //                 MEMORY_WINDOW      .
                        string sPrefixArea, //         .
                        int    nIndex);     //   .   ,   .
 //=======================================================================================================================================================================
 // 2.4.1.    TRUE,       ,   FALSE.    ANSI-.
 BOOL MemoryCheckNameA(int    nArea,          //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                       uchar &szPrefixArea[], //         .
                       uchar &szName[]);      //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.4.2.    TRUE,       ,   FALSE.    UNICODE-.
 BOOL MemoryCheckNameW(int    nArea,       //  : MEMORY_GLOBAL      .
                                           //                 MEMORY_TERMINAL    .
                                           //                 MEMORY_WINDOW      .
                       string sPrefixArea, //         .
                       string sName);      //   .
 //=======================================================================================================================================================================
 // 2.5.1.    .   TRUE     FALSE.    ANSI-.
 BOOL MemoryClearA(int    nArea,          //  : MEMORY_GLOBAL      .
                                          //                 MEMORY_TERMINAL    .
                                          //                 MEMORY_WINDOW      .
                   uchar &szPrefixArea[], //         .
                   int    nIndex,         //   .   ,   .
                   uchar &szName[]);      //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.5.2.    .   TRUE     FALSE.    UNICODE-.
 BOOL MemoryClearW(int    nArea,       //  : MEMORY_GLOBAL      .
                                       //                 MEMORY_TERMINAL    .
                                       //                 MEMORY_WINDOW      .
                   string sPrefixArea, //         .
                   int    nIndex,      //   .   ,   .
                   string sName);      //   .
 //=======================================================================================================================================================================
 // 2.6.1.          .
 //             ,        .
 //          TRUE       ,  FALSE,       .
 //           ANSI-.
 BOOL MemoryCloseAllA(int    nArea,           //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                      uchar &szPrefixArea[],  //         .
                      uchar &szNamePrefix[]); //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.6.2.          .
 //             ,        .
 //          TRUE       ,  FALSE,       .
 //           UNICODE-.
 BOOL MemoryCloseAllW(int    nArea,        //  : MEMORY_GLOBAL      .
                                           //                 MEMORY_TERMINAL    .
                                           //                 MEMORY_WINDOW      .
                      string sPrefixArea,  //         .
                      string sNamePrefix); //    .
 //=======================================================================================================================================================================
 // 2.7.1.      .   TRUE   ,  FALSE.    ANSI-.
 BOOL MemoryCloseHandleA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                         uchar &szPrefixArea[], //         .
                         int    hMemory);       //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.7.2.      .   TRUE   ,  FALSE.    UNICODE-.
 BOOL MemoryCloseHandleW(int    nArea,       //  : MEMORY_GLOBAL      .
                                             //                 MEMORY_TERMINAL    .
                                             //                 MEMORY_WINDOW      .
                         string sPrefixArea, //         .
                         int    hMemory);    //     .
 //=======================================================================================================================================================================
 // 2.8.1.               .
 //           ANSI-.
 //          TRUE       ,  FALSE,       .
 BOOL MemoryCloseHandleFileA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                             uchar &szPrefixArea[], //         .
                             int    hFileUser);     //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.8.2.               .
 //           UNICODE-.
 //          TRUE       ,  FALSE,       .
 BOOL MemoryCloseHandleFileW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                             string sPrefixArea, //         .
                             int    hFileUser);  //    .
 //=======================================================================================================================================================================
 // 2.9.1.         .   TRUE       ,  FALSE,
 //              .    ANSI-.
 BOOL MemoryCloseNameA(int    nArea,          //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                       uchar &szPrefixArea[], //         .
                       string sName);         //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.9.2.         .   TRUE       ,  FALSE,
 //              .    UNICODE-.
 BOOL MemoryCloseNameW(int    nArea,       //  : MEMORY_GLOBAL      .
                                           //                 MEMORY_TERMINAL    .
                                           //                 MEMORY_WINDOW      .
                       string sPrefixArea, //         .
                       string sName);      //   .
 //=======================================================================================================================================================================
 // 2.10.1.      .      -1.    ANSI-.
 int MemoryFreeClassesA(int    nArea,           //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                        uchar &szPrefixArea[]); //         .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.10.2.      .      -1.    UNICODE-.
 int MemoryFreeClassesW(int    nArea,        //  : MEMORY_GLOBAL      .
                                             //                 MEMORY_TERMINAL    .
                                             //                 MEMORY_WINDOW      .
                        string sPrefixArea); //         .
 //=======================================================================================================================================================================
 // 2.11.1.              .
 //               .    ANSI-.
 string MemoryFullNameByIndexA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                               uchar &szPrefixArea[], //         .
                               int    nIndex);        //   .   ,   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.11.2.              .
 //               .    UNICODE-.
 string MemoryFullNameByIndexW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                               string sPrefixArea, //         .
                               int    nIndex);     //   .   ,   .
 //=======================================================================================================================================================================
 // 2.12.1.          -1   .    ANSI-.
 //             :  0     ;
 //                                             -1      ID  ;
 //                                             -2     .
 int MemoryIndexByNameA(int    nArea,          //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                        uchar &szPrefixArea[], //         .
                        uchar &szName[]);      //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.12.2.          -1   .    UNICODE-.
 //             :  0     ;
 //                                             -1      ID  ;
 //                                             -2     .
 int MemoryIndexByNameW(int    nArea,       //  : MEMORY_GLOBAL      .
                                            //                 MEMORY_TERMINAL    .
                                            //                 MEMORY_WINDOW      .
                        string sPrefixArea, //         .
                        string sName);      //   .
 //=======================================================================================================================================================================
 // 2.13.1.    .         ,  NULL.
 //                 ,    NULL.
 //            ANSI-.
 int MemoryOpenA(int    nArea,          //  : MEMORY_GLOBAL      .
                                        //                 MEMORY_TERMINAL    .
                                        //                 MEMORY_WINDOW      .
                 uchar &szPrefixArea[], //         .
                 int    nIndex,         //   .   ,   .
                 uchar &szName[]);      //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.13.2.    .         ,  NULL.
 //                 ,    NULL.
 //            UNICODE-.
 int MemoryOpenW(int    nArea,       //  : MEMORY_GLOBAL      .
                                     //                 MEMORY_TERMINAL    .
                                     //                 MEMORY_WINDOW      .
                 string sPrefixArea, //         .
                 int    nIndex,      //   .   ,   .
                 string sName);      //   .
 //=======================================================================================================================================================================
 // 2.14.1.        .   TRUE   ,  FALSE.    ANSI-.
 BOOL MemoryResizeA(int    nArea,          //  : MEMORY_GLOBAL      .
                                           //                 MEMORY_TERMINAL    .
                                           //                 MEMORY_WINDOW      .
                    uchar &szPrefixArea[], //         .
                    int    nIndex,         //   .   ,   .
                    uchar &szName[],       //   .
                    int    nSize);         //      .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.14.2.        .   TRUE   ,  FALSE.    UNICODE-.
 BOOL MemoryResizeW(int    nArea,       //  : MEMORY_GLOBAL      .
                                        //                 MEMORY_TERMINAL    .
                                        //                 MEMORY_WINDOW      .
                    string sPrefixArea, //         .
                    int    nIndex,      //   .   ,   .
                    string sName,       //   .
                    int    nSize);      //      .
 //=======================================================================================================================================================================
 // 2.15.1.       .   TRUE     FALSE.    ANSI-.
 BOOL MemorySetA(int    nArea,          //  : MEMORY_GLOBAL      .
                                        //                 MEMORY_TERMINAL    .
                                        //                 MEMORY_WINDOW      .
                 uchar &szPrefixArea[], //         .
                 int    nIndex,         //   .   ,   .
                 uchar &szName[],       //   .
                 int    nStartByte,     //     ,     .
                 int    nValue,         //    .       .
                                        // , ,   WORD,    2 .
                 int    nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.15.2.       .   TRUE     FALSE.    UNICODE-.
 BOOL MemorySetW(int    nArea,       //  : MEMORY_GLOBAL      .
                                     //                 MEMORY_TERMINAL    .
                                     //                 MEMORY_WINDOW      .
                 string sPrefixArea, //         .
                 int    nIndex,      //   .   ,   .
                 string sName,       //   .
                 int    nStartByte,  //     ,     .
                 int    nValue,      //    .       .
                                     // , ,   WORD,    2 .
                 int    nCount);     //    .
 //=======================================================================================================================================================================
 // 2.16.1.          .    ANSI-.
 int MemorySizeA(int    nArea,          //  : MEMORY_GLOBAL      .
                                        //                 MEMORY_TERMINAL    .
                                        //                 MEMORY_WINDOW      .
                 uchar &szPrefixArea[], //         .
                 int    nIndex,         //   .   ,   .
                 uchar &szName[]);      //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.16.2.          .    UNICODE-.
 int MemorySizeW(int    nArea,       //  : MEMORY_GLOBAL      .
                                     //                 MEMORY_TERMINAL    .
                                     //                 MEMORY_WINDOW      .
                 string sPrefixArea, //         .
                 int    nIndex,      //   .   ,   .
                 string sName);      //   .
 //=======================================================================================================================================================================
 // 2.17.1.         .       .    ANSI-.
 string MemoryUserNameByIndexA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                               uchar &szPrefixArea[], //         .
                               int    nIndex);        //   .   ,   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.17.2.         .       .    UNICODE-.
 string MemoryUserNameByIndexW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                               string sPrefixArea, //         .
                               int    nIndex);     //   .   ,   .
 //
 // 3.                  .    
 //
 // 3.1.1.           /        
 //                      .
 //                      ,  NULL.
 //           ANSI-.
 size_t MemoryCreateProjectionA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                       //                 MEMORY_TERMINAL    .
                                                       //                 MEMORY_WINDOW      .
                                uchar &szPrefixArea[], //         .
                                int    hFileUser,      //    .
                                int    nIndex,         //   .   ,   .
                                uchar &szName[],       //   .
                                int    nSize);         //      .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 3.1.2.           /        
 //                      .
 //                      ,  NULL.
 //           UNICODE-.
 size_t MemoryCreateProjectionW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                                string sPrefixArea, //         .
                                int    hFileUser,   //    .
                                int    nIndex,      //   .   ,   .
                                string sName,       //   .
                                int    nSize);      //      .
 //=======================================================================================================================================================================
 // 3.2.1.                 .
 //                      ,  NULL.
 //           ANSI-.
 size_t MemoryOpenProjectionA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                     //                 MEMORY_TERMINAL    .
                                                     //                 MEMORY_WINDOW      .
                              uchar &szPrefixArea[], //         .
                              int    nIndex,         //   .   ,   .
                              uchar &szName[]);      //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 3.2.2.                 .
 //                      ,  NULL.
 //           UNICODE-.
 size_t MemoryOpenProjectionW(int    nArea,         //  : MEMORY_GLOBAL      .
                                                  //                 MEMORY_TERMINAL    .
                                                  //                 MEMORY_WINDOW      .
                              string sPrefixArea, //         .
                              int    nIndex,      //   .   ,   .
                              string sName);      //   .
 //=======================================================================================================================================================================
 // 3.3.1.          .
 //               :  (nIndex),  (sName),  (pcAddress).
 //              TRUE  FALSE   .    ANSI-.
 BOOL MemoryUnProjectionA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                          uchar &szPrefixArea[], //         .
                          int    nIndex,         //   .   ,   .
                          uchar &szName[],       //   .
                          size_t stAddress);     //          .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 3.3.2.          .
 //               :  (nIndex),  (sName),  (pcAddress).
 //              TRUE  FALSE   .    UNICODE-.
 BOOL MemoryUnProjectionW(int    nArea,       //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                          string sPrefixArea, //         .
                          int    nIndex,      //   .   ,   .
                          string sName,       //   .
                          size_t stAddress);  //          .
 //=======================================================================================================================================================================
 // 3.4.1.               .
 //                      ,  NULL.
 //           ANSI-.
 size_t MemoryProjectionByHandleA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                         //                 MEMORY_TERMINAL    .
                                                         //                 MEMORY_WINDOW      .
                                  uchar &szPrefixArea[], //         .
                                  int    nIndex,         //   .   ,   .
                                  int    hMemory);       //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 3.4.2.               .
 //                      ,  NULL.
 //           UNICODE-.
 size_t MemoryProjectionByHandleW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                                  string sPrefixArea, //         .
                                  int    nIndex,      //   .   ,   .
                                  int    hMemory);    //    .
 //=======================================================================================================================================================================
 // 3.5.1.               .
 //                      ,  NULL.
 //           ANSI-.
 size_t MemoryProjectionByNameA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                       //                 MEMORY_TERMINAL    .
                                                       //                 MEMORY_WINDOW      .
                                uchar &szPrefixArea[], //         .
                                int    nIndex,         //   .   ,   .
                                string sName);         //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 3.5.2.               .
 //                      ,  NULL.
 //           UNICODE-.
 size_t MemoryProjectionByNameW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                                string sPrefixArea, //         .
                                int    nIndex,      //   .   ,   .
                                string sName);      //   .
 //
 // 4.             .    
 //
 // 4.1.1.           BOOL (1 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteBoolA(int    nArea,          //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                       uchar &szPrefixArea[], //         .
                       int    nIndex,         //   .   ,   .
                       uchar &szName[],       //   .
                       int    nStartByte,     //      ,     .
                       bool   bValue);        //   BOOL (1 )     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.1.2.           BOOL (1 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteBoolW(int    nArea,       //  : MEMORY_GLOBAL      .
                                           //                 MEMORY_TERMINAL    .
                                           //                 MEMORY_WINDOW      .
                       string sPrefixArea, //         .
                       int    nIndex,      //   .   ,   .
                       string sName,       //   .
                       int    nStartByte,  //      ,     .
                       bool   bValue);     //   BOOL (1 )     .
 //=======================================================================================================================================================================
 // 4.2.1.           CHAR (1 )     .
 //            INT (4 )  CHAR (1 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteCharA(int    nArea,          //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                       uchar &szPrefixArea[], //         .
                       int    nIndex,         //   .   ,   .
                       uchar &szName[],       //   .
                       int    nStartByte,     //      ,     .
                       char   cValue);        //   CHAR (1 )     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.2.2.           CHAR (1 )     .
 //            INT (4 )  CHAR (1 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteCharW(int    nArea,       //  : MEMORY_GLOBAL      .
                                           //                 MEMORY_TERMINAL    .
                                           //                 MEMORY_WINDOW      .
                       string sPrefixArea, //         .
                       int    nIndex,      //   .   ,   .
                       string sName,       //   .
                       int    nStartByte,  //      ,     .
                       char   cValue);     //   CHAR (1 )     .
 //=======================================================================================================================================================================
 // 4.3.1.           UCHAR (1 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteUCharA(int    nArea,          //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                        uchar &szPrefixArea[], //         .
                        int    nIndex,         //   .   ,   .
                        uchar &szName[],       //   .
                        int    nStartByte,     //      ,     .
                        uchar  ucValue);       //   UCHAR (1 )     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.3.2.           UCHAR (1 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteUCharW(int    nArea,       //  : MEMORY_GLOBAL      .
                                            //                 MEMORY_TERMINAL    .
                                            //                 MEMORY_WINDOW      .
                        string sPrefixArea, //         .
                        int    nIndex,      //   .   ,   .
                        string sName,       //   .
                        int    nStartByte,  //      ,     .
                        uchar  ucValue);    //   UCHAR (1 )     .
 //=======================================================================================================================================================================
 // 4.4.1.           SHORT (2 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteShortA(int    nArea,          //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                        uchar &szPrefixArea[], //         .
                        int    nIndex,         //   .   ,   .
                        uchar &szName[],       //   .
                        int    nStartByte,     //      ,     .
                        short  shValue);       //   SHORT (2 )     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.4.2.           SHORT (2 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteShortW(int    nArea,       //  : MEMORY_GLOBAL      .
                                            //                 MEMORY_TERMINAL    .
                                            //                 MEMORY_WINDOW      .
                        string sPrefixArea, //         .
                        int    nIndex,      //   .   ,   .
                        string sName,       //   .
                        int    nStartByte,  //      ,     .
                        short  shValue);    //   SHORT (2 )     .
 //=======================================================================================================================================================================
 // 4.5.1.           USHORT (2 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteUShortA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                         uchar &szPrefixArea[], //         .
                         int    nIndex,         //   .   ,   .
                         uchar &szName[],       //   .
                         int    nStartByte,     //      ,     .
                         ushort ushValue);      //   USHORT (2 )     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.5.2.           USHORT (2 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteUShortW(int    nArea,       //  : MEMORY_GLOBAL      .
                                             //                 MEMORY_TERMINAL    .
                                             //                 MEMORY_WINDOW      .
                         string sPrefixArea, //         .
                         int    nIndex,      //   .   ,   .
                         string sName,       //   .
                         int    nStartByte,  //      ,     .
                         ushort ushValue);   //   USHORT (2 )     .
 //=======================================================================================================================================================================
 // 4.6.1.           INT (4 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteIntA(int    nArea,          //  : MEMORY_GLOBAL      .
                                             //                 MEMORY_TERMINAL    .
                                             //                 MEMORY_WINDOW      .
                      uchar &szPrefixArea[], //         .
                      int    nIndex,         //   .   ,   .
                      uchar &szName[],       //   .
                      int    nStartByte,     //      ,     .
                      int    nValue);        //   INT (4 )     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.6.2.           INT (4 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteIntW(int    nArea,       //  : MEMORY_GLOBAL      .
                                          //                 MEMORY_TERMINAL    .
                                          //                 MEMORY_WINDOW      .
                      string sPrefixArea, //         .
                      int    nIndex,      //   .   ,   .
                      string sName,       //   .
                      int    nStartByte,  //      ,     .
                      int    nValue);     //   INT (4 )     .
 //=======================================================================================================================================================================
 // 4.7.1.           UINT (4 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteUIntA(int    nArea,          //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                       uchar &szPrefixArea[], //         .
                       int    nIndex,         //   .   ,   .
                       uchar &szName[],       //   .
                       int    nStartByte,     //      ,     .
                       uint   uiValue);       //   UINT (4 )     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.7.2.           UINT (4 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteUIntW(int    nArea,       //  : MEMORY_GLOBAL      .
                                           //                 MEMORY_TERMINAL    .
                                           //                 MEMORY_WINDOW      .
                       string sPrefixArea, //         .
                       int    nIndex,      //   .   ,   .
                       string sName,       //   .
                       int    nStartByte,  //      ,     .
                       uint   uiValue);    //   UINT (4 )     .
 //=======================================================================================================================================================================
 // 4.8.1.           INT64 (8 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteLongA(int    nArea,          //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                       uchar &szPrefixArea[], //         .
                       int    nIndex,         //   .   ,   .
                       uchar &szName[],       //   .
                       int    nStartByte,     //      ,     .
                       long   lValue);        //   INT64 (8 )     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.8.2.           INT64 (8 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteLongW(int    nArea,       //  : MEMORY_GLOBAL      .
                                           //                 MEMORY_TERMINAL    .
                                           //                 MEMORY_WINDOW      .
                       string sPrefixArea, //         .
                       int    nIndex,      //   .   ,   .
                       string sName,       //   .
                       int    nStartByte,  //      ,     .
                       long   lValue);     //   INT64 (8 )     .
 //=======================================================================================================================================================================
 // 4.9.1.           UINT64 (8 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteULongA(int    nArea,          //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                        uchar &szPrefixArea[], //         .
                        int    nIndex,         //   .   ,   .
                        uchar &szName[],       //   .
                        int    nStartByte,     //      ,     .
                        ulong  ulValue);       //   UINT64 (8 )     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.9.2.           UINT64 (8 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteULongW(int    nArea,       //  : MEMORY_GLOBAL      .
                                            //                 MEMORY_TERMINAL    .
                                            //                 MEMORY_WINDOW      .
                        string sPrefixArea, //         .
                        int    nIndex,      //   .   ,   .
                        string sName,       //   .
                        int    nStartByte,  //      ,     .
                        ulong  ulValue);    //   UINT64 (8 )     .
 //=======================================================================================================================================================================
 // 4.10.1.           FLOAT (4 )     .
 //           TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteFloatA(int    nArea,          //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                        uchar &szPrefixArea[], //         .
                        int    nIndex,         //   .   ,   .
                        uchar &szName[],       //   .
                        int    nStartByte,     //      ,     .
                        float  fValue);        //   FLOAT (4 )     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.10.2.           FLOAT (4 )     .
 //           TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteFloatW(int    nArea,       //  : MEMORY_GLOBAL      .
                                            //                 MEMORY_TERMINAL    .
                                            //                 MEMORY_WINDOW      .
                        string sPrefixArea, //         .
                        int    nIndex,      //   .   ,   .
                        string sName,       //   .
                        int    nStartByte,  //      ,     .
                        float  fValue);     //   FLOAT (4 )     .
 //=======================================================================================================================================================================
 // 4.11.1.           DOUBLE (8 )     .    ,   .
 //           TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteDoubleA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                         uchar &szPrefixArea[], //         .
                         int    nIndex,         //   .   ,   .
                         uchar &szName[],       //   .
                         int    nStartByte,     //      ,     .
                         double dValue);        //   DOUBLE (8 )     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.11.2.           DOUBLE (8 )     .    ,   .
 //           TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteDoubleW(int    nArea,       //  : MEMORY_GLOBAL      .
                                             //                 MEMORY_TERMINAL    .
                                             //                 MEMORY_WINDOW      .
                         string sPrefixArea, //         .
                         int    nIndex,      //   .   ,   .
                         string sName,       //   .
                         int    nStartByte,  //      ,     .
                         double dValue);     //   DOUBLE (8 )     .
 //=======================================================================================================================================================================
 // 4.12.1.         ANSI-     .
 //           TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteStringA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                         uchar &szPrefixArea[], //         .
                         int    nIndex,         //   .   ,   .
                         uchar &szName[],       //   .
                         int    nStartByte,     //      ,     .
                         string sString);       //      .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.12.2.         UNICODE-     .
 //           TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteStringW(int    nArea,       //  : MEMORY_GLOBAL      .
                                             //                 MEMORY_TERMINAL    .
                                             //                 MEMORY_WINDOW      .
                         string sPrefixArea, //         .
                         int    nIndex,      //   .   ,   .
                         string sName,       //   .
                         int    nStartByte,  //      ,     .
                         string sString);    //      .
 //=======================================================================================================================================================================
 // 4.13.1.    ,  ANSI-  UNICODE-,        .
 //           TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteStringAnsiToUnicodeA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                             //                 MEMORY_TERMINAL    .
                                                             //                 MEMORY_WINDOW      .
                                      uchar &szPrefixArea[], //         .
                                      int    nIndex,         //   .   ,   .
                                      uchar &szName[],       //   .
                                      int    nStartByte,     //      ,     .
                                      string sString);       //      .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.13.2.    ,  ANSI-  UNICODE-,        .
 //           TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteStringAnsiToUnicodeW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                      string sPrefixArea, //         .
                                      int    nIndex,      //   .   ,   .
                                      string sName,       //   .
                                      int    nStartByte,  //      ,     .
                                      string sString);    //      .
 //=======================================================================================================================================================================
 // 4.14.1.    ,  UNICODE-  ANSI-,        .
 //           TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteStringUnicodeToAnsiA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                             //                 MEMORY_TERMINAL    .
                                                             //                 MEMORY_WINDOW      .
                                      uchar &szPrefixArea[], //         .
                                      int    nIndex,         //   .   ,   .
                                      uchar &szName[],       //   .
                                      int    nStartByte,     //      ,     .
                                      string sString);       //      .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.14.2.    ,  UNICODE-  ANSI-,        .
 //           TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteStringUnicodeToAnsiW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                          //                 MEMORY_TERMINAL    .
                                                          //                 MEMORY_WINDOW      .
                                      string sPrefixArea, //         .
                                      int    nIndex,      //   .   ,   .
                                      string sName,       //   .
                                      int    nStartByte,  //      ,     .
                                      string sString);    //      .
 //
 // 5.             .    
 //
 // 5.1.1.        BOOL (1 )     .
 //             FALSE   .    ANSI-.
 bool MemoryReadBoolA(int    nArea,          //  : MEMORY_GLOBAL      .
                                             //                 MEMORY_TERMINAL    .
                                             //                 MEMORY_WINDOW      .
                      uchar &szPrefixArea[], //         .
                      int    nIndex,         //   .   ,   .
                      uchar &szName[],       //   .
                      int    nStartByte);    //      ,     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.1.2.        BOOL (1 )     .
 //             FALSE   .    UNICODE-.
 bool MemoryReadBoolW(int    nArea,       //  : MEMORY_GLOBAL      .
                                          //                 MEMORY_TERMINAL    .
                                          //                 MEMORY_WINDOW      .
                      string sPrefixArea, //         .
                      int    nIndex,      //   .   ,   .
                      string sName,       //   .
                      int    nStartByte); //      ,     .
 //=======================================================================================================================================================================
 // 5.2.1.        CHAR (1 )     .
 //                .    ANSI-.
 char MemoryReadCharA(int    nArea,          //  : MEMORY_GLOBAL      .
                                             //                 MEMORY_TERMINAL    .
                                             //                 MEMORY_WINDOW      .
                      uchar &szPrefixArea[], //         .
                      int    nIndex,         //   .   ,   .
                      uchar &szName[],       //   .
                      int    nStartByte);    //      ,     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.2.2.        CHAR (1 )     .
 //                .    UNICODE-.
 char MemoryReadCharW(int    nArea,       //  : MEMORY_GLOBAL      .
                                          //                 MEMORY_TERMINAL    .
                                          //                 MEMORY_WINDOW      .
                      string sPrefixArea, //         .
                      int    nIndex,      //   .   ,   .
                      string sName,       //   .
                      int    nStartByte); //      ,     .
 //=======================================================================================================================================================================
 // 5.3.1.        UCHAR (1 )     .
 //                .    ANSI-.
 uchar MemoryReadUCharA(int    nArea,          //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                        uchar &szPrefixArea[], //         .
                        int    nIndex,         //   .   ,   .
                        uchar &szName[],       //   .
                        int    nStartByte);    //      ,     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.2.        UCHAR (1 )     .
 //                .    UNICODE-.
 uchar MemoryReadUCharW(int    nArea,       //  : MEMORY_GLOBAL      .
                                            //                 MEMORY_TERMINAL    .
                                            //                 MEMORY_WINDOW      .
                        string sPrefixArea, //         .
                        int    nIndex,      //   .   ,   .
                        string sName,       //   .
                        int    nStartByte); //      ,     .
 //=======================================================================================================================================================================
 // 5.4.1.        SHORT (2 )     .
 //                .    ANSI-.
 short MemoryReadShortA(int    nArea,          //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                        uchar &szPrefixArea[], //         .
                        int    nIndex,         //   .   ,   .
                        uchar &szName[],       //   .
                        int    nStartByte);    //      ,     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.2.        SHORT (2 )     .
 //                .    UNICODE-.
 short MemoryReadShortW(int    nArea,       //  : MEMORY_GLOBAL      .
                                            //                 MEMORY_TERMINAL    .
                                            //                 MEMORY_WINDOW      .
                        string sPrefixArea, //         .
                        int    nIndex,      //   .   ,   .
                        string sName,       //   .
                        int    nStartByte); //      ,     .
 //=======================================================================================================================================================================
 // 5.5.1.        USHORT (2 )     .
 //                .    ANSI-.
 ushort MemoryReadUShortA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                          uchar &szPrefixArea[], //         .
                          int    nIndex,         //   .   ,   .
                          uchar &szName[],       //   .
                          int    nStartByte);    //      ,     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.2.        USHORT (2 )     .
 //                .    UNICODE-.
 ushort MemoryReadUShortW(int    nArea,       //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                          string sPrefixArea, //         .
                          int    nIndex,      //   .   ,   .
                          string sName,       //   .
                          int    nStartByte); //      ,     .
 //=======================================================================================================================================================================
 // 5.6.1.        INT (4 )     .
 //                .    ANSI-.
 int MemoryReadIntA(int    nArea,          //  : MEMORY_GLOBAL      .
                                           //                 MEMORY_TERMINAL    .
                                           //                 MEMORY_WINDOW      .
                    uchar &szPrefixArea[], //         .
                    int    nIndex,         //   .   ,   .
                    uchar &szName[],       //   .
                    int    nStartByte);    //      ,     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.2.        INT (4 )     .
 //                .    UNICODE-.
 int MemoryReadIntW(int    nArea,       //  : MEMORY_GLOBAL      .
                                        //                 MEMORY_TERMINAL    .
                                        //                 MEMORY_WINDOW      .
                    string sPrefixArea, //         .
                    int    nIndex,      //   .   ,   .
                    string sName,       //   .
                    int    nStartByte); //      ,     .
 //=======================================================================================================================================================================
 // 5.7.1.        UINT (4 )     .
 //                .    ANSI-.
 uint MemoryReadUIntA(int    nArea,          //  : MEMORY_GLOBAL      .
                                             //                 MEMORY_TERMINAL    .
                                             //                 MEMORY_WINDOW      .
                      uchar &szPrefixArea[], //         .
                      int    nIndex,         //   .   ,   .
                      uchar &szName[],       //   .
                      int    nStartByte);    //      ,     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.7.2.        UINT (4 )     .
 //                .    UNICODE-.
 uint MemoryReadUIntW(int    nArea,       //  : MEMORY_GLOBAL      .
                                          //                 MEMORY_TERMINAL    .
                                          //                 MEMORY_WINDOW      .
                      string sPrefixArea, //         .
                      int    nIndex,      //   .   ,   .
                      string sName,       //   .
                      int    nStartByte); //      ,     .
 //=======================================================================================================================================================================
 // 5.8.1.        INT64 (8 )     .
 //                .    ANSI-.
 long MemoryReadLongA(int    nArea,          //  : MEMORY_GLOBAL      .
                                             //                 MEMORY_TERMINAL    .
                                             //                 MEMORY_WINDOW      .
                      uchar &szPrefixArea[], //         .
                      int    nIndex,         //   .   ,   .
                      uchar &szName[],       //   .
                      int    nStartByte);    //      ,     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.8.2.        INT64 (8 )     .
 //                .    UNICODE-.
 long MemoryReadLongW(int    nArea,       //  : MEMORY_GLOBAL      .
                                          //                 MEMORY_TERMINAL    .
                                          //                 MEMORY_WINDOW      .
                      string sPrefixArea, //         .
                      int    nIndex,      //   .   ,   .
                      string sName,       //   .
                      int    nStartByte); //      ,     .
 //=======================================================================================================================================================================
 // 5.9.1.        UINT64 (8 )     .
 //                .    ANSI-.
 ulong MemoryReadULongA(int    nArea,          //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                        uchar &szPrefixArea[], //         .
                        int    nIndex,         //   .   ,   .
                        uchar &szName[],       //   .
                        int    nStartByte);    //      ,     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.9.2.        UINT64 (8 )     .
 //                .    UNICODE-.
 ulong MemoryReadULongW(int    nArea,       //  : MEMORY_GLOBAL      .
                                            //                 MEMORY_TERMINAL    .
                                            //                 MEMORY_WINDOW      .
                        string sPrefixArea, //         .
                        int    nIndex,      //   .   ,   .
                        string sName,       //   .
                        int    nStartByte); //      ,     .
 //=======================================================================================================================================================================
 // 5.10.1.        FLOAT (4 )     .         .
 float MemoryReadFloatA(int    nArea,          //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                        uchar &szPrefixArea[], //         .
                        int    nIndex,         //   .   ,   .
                        uchar &szName[],       //   .
                        int    nStartByte);    //      ,     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.10.2.        FLOAT (4 )     .         .
 float MemoryReadFloatW(int    nArea,       //  : MEMORY_GLOBAL      .
                                            //                 MEMORY_TERMINAL    .
                                            //                 MEMORY_WINDOW      .
                        string sPrefixArea, //         .
                        int    nIndex,      //   .   ,   .
                        string sName,       //   .
                        int    nStartByte); //      ,     .
 //=======================================================================================================================================================================
 // 5.11.1.        DOUBLE (8 )     .
 //                .    ANSI-.
 double MemoryReadDoubleA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                          uchar &szPrefixArea[], //         .
                          int    nIndex,         //   .   ,   .
                          uchar &szName[],       //   .
                          int    nStartByte);    //      ,     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.11.2.        DOUBLE (8 )     .
 //                .    UNICODE-.
 double MemoryReadDoubleW(int    nArea,       //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                          string sPrefixArea, //         .
                          int    nIndex,      //   .   ,   .
                          string sName,       //   .
                          int    nStartByte); //      ,     .
 //=======================================================================================================================================================================
 // 5.12.1.      ANSI-           .
 //             NULL.    ANSI-.
 string MemoryReadStringA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                          uchar &szPrefixArea[], //         .
                          int    nIndex,         //   .   ,   .
                          uchar &szName[],       //   .
                          int    nStartByte,     //      ,     .
                          int    nLength);       //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.12.2.      UNICODE-           .
 //             NULL.    UNICODE-.
 string MemoryReadStringW(int    nArea,       //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                          string sPrefixArea, //         .
                          int    nIndex,      //   .   ,   .
                          string sName,       //   .
                          int    nStartByte,  //      ,     .
                          int    nLength);    //     .
 //=======================================================================================================================================================================
 // 5.13.1.      ANSI-     ,    UNICODE-      UNICODE-.
 //              NULL.    ANSI-.
 string MemoryReadStringAnsiToUnicodeA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                       uchar &szPrefixArea[], //         .
                                       int    nIndex,         //   .   ,   .
                                       uchar &szName[],       //   .
                                       int    nStartByte,     //      ,     .
                                       int    nLength);       //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.13.2.      ANSI-     ,    UNICODE-      UNICODE-.
 //              NULL.    UNICODE-.
 string MemoryReadStringAnsiToUnicodeW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                           //                 MEMORY_TERMINAL    .
                                                           //                 MEMORY_WINDOW      .
                                       string sPrefixArea, //         .
                                       int    nIndex,      //   .   ,   .
                                       string sName,       //   .
                                       int    nStartByte,  //      ,     .
                                       int    nLength);    //     .
 //=======================================================================================================================================================================
 // 5.14.1.      UNICODE-     ,    ANSI-      ANSI-.
 //              NULL.    ANSI-.
 string MemoryReadStringUnicodeToAnsiA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                              //                 MEMORY_TERMINAL    .
                                                              //                 MEMORY_WINDOW      .
                                       uchar &szPrefixArea[], //         .
                                       int    nIndex,         //   .   ,   .
                                       uchar &szName[],       //   .
                                       int    nStartByte,     //      ,     .
                                       int    nLength);       //     .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.14.2.      UNICODE-     ,    ANSI-      ANSI-.
 //              NULL.    UNICODE-.
 string MemoryReadStringUnicodeToAnsiW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                           //                 MEMORY_TERMINAL    .
                                                           //                 MEMORY_WINDOW      .
                                       string sPrefixArea, //         .
                                       int    nIndex,      //   .   ,   .
                                       string sName,       //   .
                                       int    nStartByte,  //      ,     .
                                       int    nLength);    //     .
 //
 // 6.           .    
 //
 // 6.1.1.             BOOL (1 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteBoolArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                            uchar &szPrefixArea[], //         .
                            int    nIndex,         //   .   ,   .
                            uchar &szName[],       //   .
                            int    nStartByte,     //      ,     .
                            bool  &abArray[],      //        BOOL     .
                            int    nSizeArray,     //   (  ).
                            int    nStart,         //     (   ).
                            int    nCount);        //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.2.             BOOL     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteBoolArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                            string sPrefixArea, //         .
                            int    nIndex,      //   .   ,   .
                            string sName,       //   .
                            int    nStartByte,  //      ,     .
                            bool  &abArray[],   //        BOOL     .
                            int    nSizeArray,  //   (  ).
                            int    nStart,      //     (   ).
                            int    nCount);     //   .
 //=======================================================================================================================================================================
 // 6.2.1.             CHAR (1 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteCharArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                            uchar &szPrefixArea[], //         .
                            int    nIndex,         //   .   ,   .
                            uchar &szName[],       //   .
                            int    nStartByte,     //      ,     .
                            char  &acArray[],      //       CHAR (1 )     .
                            int    nSizeArray,     //   (  ).
                            int    nStart,         //     (   ).
                            int    nCount);        //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.2.             CHAR (1 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteCharArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                            string sPrefixArea, //         .
                            int    nIndex,      //   .   ,   .
                            string sName,       //   .
                            int    nStartByte,  //      ,     .
                            char  &acArray[],   //       CHAR (1 )     .
                            int    nSizeArray,  //   (  ).
                            int    nStart,      //     (   ).
                            int    nCount);     //   .
 //=======================================================================================================================================================================
 // 6.3.1.             UCHAR (1 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteUCharArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                             uchar &szPrefixArea[], //         .
                             int    nIndex,         //   .   ,   .
                             uchar &szName[],       //   .
                             int    nStartByte,     //      ,     .
                             uchar &aucArray[],     //       UCHAR (1 )     .
                             int    nSizeArray,     //   (  ).
                             int    nStart,         //     (   ).
                             int    nCount);        //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.2.             UCHAR (1 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteUCharArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                             string sPrefixArea, //         .
                             int    nIndex,      //   .   ,   .
                             string sName,       //   .
                             int    nStartByte,  //      ,     .
                             uchar &aucArray[],  //       UCHAR (1 )     .
                             int    nSizeArray,  //   (  ).
                             int    nStart,      //     (   ).
                             int    nCount);     //   .
 //=======================================================================================================================================================================
 // 6.4.1.             SHORT (2 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteShortArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                             uchar &szPrefixArea[], //         .
                             int    nIndex,         //   .   ,   .
                             uchar &szName[],       //   .
                             int    nStartByte,     //      ,     .
                             short &ashArray[],     //       SHORT (2 )     .
                             int    nSizeArray,     //   (  ).
                             int    nStart,         //     (   ).
                             int    nCount);        //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.2.             SHORT (2 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteShortArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                             string sPrefixArea, //         .
                             int    nIndex,      //   .   ,   .
                             string sName,       //   .
                             int    nStartByte,  //      ,     .
                             short &ashArray[],  //       SHORT (2 )     .
                             int    nSizeArray,  //   (  ).
                             int    nStart,      //     (   ).
                             int    nCount);     //   .
 //=======================================================================================================================================================================
 // 6.5.1.             USHORT (2 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteUShortArrayA(int     nArea,          //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                              uchar  &szPrefixArea[], //         .
                              int     nIndex,         //   .   ,   .
                              uchar  &szName[],       //   .
                              int     nStartByte,     //      ,     .
                              ushort &aushArray[],    //       USHORT (2 )     .
                              int     nSizeArray,     //   (  ).
                              int     nStart,         //     (   ).
                              int     nCount);        //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.5.2.             USHORT (2 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteUShortArrayW(int     nArea,       //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                              string  sPrefixArea, //         .
                              int     nIndex,      //   .   ,   .
                              string  sName,       //   .
                              int     nStartByte,  //      ,     .
                              ushort &aushArray[], //       USHORT (2 )     .
                              int     nSizeArray,  //   (  ).
                              int     nStart,      //     (   ).
                              int     nCount);     //   .
 //=======================================================================================================================================================================
 // 6.6.1.             INT (4 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteIntArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                  //                 MEMORY_TERMINAL    .
                                                  //                 MEMORY_WINDOW      .
                           uchar &szPrefixArea[], //         .
                           int    nIndex,         //   .   ,   .
                           uchar &szName[],       //   .
                           int    nStartByte,     //      ,     .
                           int   &aiArray[],      //       INT (4 )     .
                           int    nSizeArray,     //   (  ).
                           int    nStart,         //     (   ).
                           int    nCount);        //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.6.2.             INT (4 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteIntArrayW(int  nArea,         //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                           string sPrefixArea, //         .
                           int    nIndex,      //   .   ,   .
                           string sName,       //   .
                           int    nStartByte,  //      ,     .
                           int   &aiArray[],   //       INT (4 )     .
                           int    nSizeArray,  //   (  ).
                           int    nStart,      //     (   ).
                           int    nCount);     //   .
 //=======================================================================================================================================================================
 // 6.7.1.             UINT (4 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteUIntArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                            uchar &szPrefixArea[], //         .
                            int    nIndex,         //   .   ,   .
                            uchar &szName[],       //   .
                            int    nStartByte,     //      ,     .
                            uint  &auiArray[],     //       UINT (4 )     .
                            int    nSizeArray,     //   (  ).
                            int    nStart,         //     (   ).
                            int    nCount);        //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.7.2.             UINT (4 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteUIntArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                            string sPrefixArea, //         .
                            int    nIndex,      //   .   ,   .
                            string sName,       //   .
                            int    nStartByte,  //      ,     .
                            uint  &auiArray[],  //       UINT (4 )     .
                            int    nSizeArray,  //   (  ).
                            int    nStart,      //     (   ).
                            int    nCount);     //   .
 //=======================================================================================================================================================================
 // 6.8.1.             INT64 (8 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteLongArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                            uchar &szPrefixArea[], //         .
                            int    nIndex,         //   .   ,   .
                            uchar &szName[],       //   .
                            int    nStartByte,     //      ,     .
                            long  &alArray[],      //       INT64 (8 )     .
                            int    nSizeArray,     //   (  ).
                            int    nStart,         //     (   ).
                            int    nCount);        //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.8.2.             INT64 (8 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteLongArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                            string sPrefixArea, //         .
                            int    nIndex,      //   .   ,   .
                            string sName,       //   .
                            int    nStartByte,  //      ,     .
                            long  &alArray[],   //       INT64 (8 )     .
                            int    nSizeArray,  //   (  ).
                            int    nStart,      //     (   ).
                            int    nCount);     //   .
 //=======================================================================================================================================================================
 // 6.9.1.             UINT64 (8 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteULongArrayA(int     nArea,         //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                             uchar &szPrefixArea[], //         .
                             int    nIndex,         //   .   ,   .
                             uchar &szName[],       //   .
                             int    nStartByte,     //      ,     .
                             ulong &aulArray[],     //       UINT64 (8 )     .
                             int    nSizeArray,     //   (  ).
                             int    nStart,         //     (   ).
                             int    nCount);        //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.9.2.             INT64 (8 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteULongArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                             string sPrefixArea, //         .
                             int    nIndex,      //   .   ,   .
                             string sName,       //   .
                             int    nStartByte,  //      ,     .
                             ulong &aulArray[],  //       UINT64 (8 )     .
                             int    nSizeArray,  //   (  ).
                             int    nStart,      //     (   ).
                             int    nCount);     //   .
 //=======================================================================================================================================================================
 // 6.10.1.             FLOAT (4 )     .
 //           TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteFloatArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                    //                 MEMORY_TERMINAL    .
                                                    //                 MEMORY_WINDOW      .
                             uchar &szPrefixArea[], //         .
                             int    nIndex,         //   .   ,   .
                             uchar &szName[],       //   .
                             int    nStartByte,     //      ,     .
                             float &afArray[],      //       FLOAT (4 )     .
                             int    nSizeArray,     //   (  ).
                             int    nStart,         //     (   ).
                             int    nCount);        //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.10.2.             FLOAT (4 )     .
 //           TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteFloatArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                             string sPrefixArea, //         .
                             int    nIndex,      //   .   ,   .
                             string sName,       //   .
                             int    nStartByte,  //      ,     .
                             float &afArray[],   //       FLOAT (4 )     .
                             int    nSizeArray,  //   (  ).
                             int    nStart,      //     (   ).
                             int    nCount);     //   .
 //=======================================================================================================================================================================
 // 6.11.1.             DOUBLE (8 )     .
 //            ,   .
 //           TRUE     - FALSE.    ANSI-.
 BOOL MemoryWriteDoubleArrayA(int     nArea,          //  : MEMORY_GLOBAL      .
                                                      //                 MEMORY_TERMINAL    .
                                                      //                 MEMORY_WINDOW      .
                              uchar  &szPrefixArea[], //         .
                              int     nIndex,         //   .   ,   .
                              uchar  &szName[],       //   .
                              int     nStartByte,     //      ,     .
                              double &adArray[],      //       DOUBLE (8 )     .
                              int     nSizeArray,     //   (  ).
                              int     nStart,         //     (   ).
                              int     nCount);        //   .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.11.2.             DOUBLE (8 )     .
 //            ,   .
 //           TRUE     - FALSE.    UNICODE-.
 BOOL MemoryWriteDoubleArrayW(int     nArea,       //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                              string  sPrefixArea, //         .
                              int     nIndex,      //   .   ,   .
                              string  sName,       //   .
                              int     nStartByte,  //      ,     .
                              double &adArray[],   //       DOUBLE (8 )     .
                              int     nSizeArray,  //   (  ).
                              int     nStart,      //     (   ).
                              int     nCount);     //   .
 //
 // 7.           .    
 //
 // 7.1.1.        BOOL (1 )    BOOL (1 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryReadBoolArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                  //                 MEMORY_TERMINAL    .
                                                  //                 MEMORY_WINDOW      .
                           uchar &szPrefixArea[], //         .
                           int    nIndex,         //   .   ,   .
                           uchar &szName[],       //   .
                           int    nStartByte,     //      ,      .
                           bool  &abArray[],      //           BOOL   .
                           int    nSizeArray,     //   (  ).
                           int    nStart,         //       (   ).
                           int    nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.1.2.        BOOL (1 )    BOOL (1 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryReadBoolArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                           string sPrefixArea, //         .
                           int    nIndex,      //   .   ,   .
                           string sName,       //   .
                           int    nStartByte,  //      ,      .
                           bool  &abArray[],   //           BOOL   .
                           int    nSizeArray,  //   (  ).
                           int    nStart,      //       (   ).
                           int    nCount);     //    .
 //=======================================================================================================================================================================
 // 7.2.1.        CHAR (1 )    CHAR (1 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryReadCharArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                  //                 MEMORY_TERMINAL    .
                                                  //                 MEMORY_WINDOW      .
                           uchar &szPrefixArea[], //         .
                           int    nIndex,         //   .   ,   .
                           uchar &szName[],       //   .
                           int    nStartByte,     //      ,      .
                           char  &acArray[],      //          CHAR (1 )   .
                           int    nSizeArray,     //   (  ).
                           int    nStart,         //       (   ).
                           int    nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.2.2.        CHAR (1 )    CHAR (1 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryReadCharArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                           string sPrefixArea, //         .
                           int    nIndex,      //   .   ,   .
                           string sName,       //   .
                           int    nStartByte,  //      ,      .
                           char  &acArray[],   //          CHAR (1 )   .
                           int    nSizeArray,  //   (  ).
                           int    nStart,      //       (   ).
                           int    nCount);     //    .
 //=======================================================================================================================================================================
 // 7.3.1.        UCHAR (1 )    UCHAR (1 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryReadUCharArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                            uchar &szPrefixArea[], //         .
                            int    nIndex,         //   .   ,   .
                            uchar &szName[],       //   .
                            int    nStartByte,     //      ,      .
                            uchar &aucArray[],     //          UCHAR (1 )   .
                            int    nSizeArray,     //   (  ).
                            int    nStart,         //       (   ).
                            int    nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.3.2.        UCHAR (1 )    UCHAR (1 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryReadUCharArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                            string sPrefixArea, //         .
                            int    nIndex,      //   .   ,   .
                            string sName,       //   .
                            int    nStartByte,  //      ,      .
                            uchar &aucArray[],  //          UCHAR (1 )   .
                            int    nSizeArray,  //   (  ).
                            int    nStart,      //       (   ).
                            int    nCount);     //    .
 //=======================================================================================================================================================================
 // 7.4.1.        SHORT (2 )    SHORT (2 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryReadShortArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                            uchar &szPrefixArea[], //         .
                            int    nIndex,         //   .   ,   .
                            uchar &szName[],       //   .
                            int    nStartByte,     //      ,      .
                            short &ashArray[],     //          SHORT (2 )   .
                            int    nSizeArray,     //   (  ).
                            int    nStart,         //       (   ).
                            int    nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.4.2.        SHORT (2 )    SHORT (2 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryReadShortArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                            string sPrefixArea, //         .
                            int    nIndex,      //   .   ,   .
                            string sName,       //   .
                            int    nStartByte,  //      ,      .
                            short &ashArray[],  //          SHORT (2 )   .
                            int    nSizeArray,  //   (  ).
                            int    nStart,      //       (   ).
                            int    nCount);     //    .
 //=======================================================================================================================================================================
 // 7.5.1.        USHORT (2 )    USHORT (2 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryReadUShortArrayA(int     nArea,          //  : MEMORY_GLOBAL      .
                                                     //                 MEMORY_TERMINAL    .
                                                     //                 MEMORY_WINDOW      .
                             uchar  &szPrefixArea[], //         .
                             int     nIndex,         //   .   ,   .
                             uchar  &szName[],       //   .
                             int     nStartByte,     //      ,      .
                             ushort &aushArray[],    //          USHORT (2 )   .
                             int     nSizeArray,     //   (  ).
                             int     nStart,         //       (   ).
                             int     nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.5.2.        USHORT (2 )    USHORT (2 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryReadUShortArrayW(int     nArea,       //  : MEMORY_GLOBAL      .
                                                  //                 MEMORY_TERMINAL    .
                                                  //                 MEMORY_WINDOW      .
                             string  sPrefixArea, //         .
                             int     nIndex,      //   .   ,   .
                             string  sName,       //   .
                             int     nStartByte,  //      ,      .
                             ushort &aushArray[], //          USHORT (2 )   .
                             int     nSizeArray,  //   (  ).
                             int     nStart,      //       (   ).
                             int     nCount);     //    .
 //=======================================================================================================================================================================
 // 7.6.1.        INT (4 )    INT (4 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryReadIntArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                 //                 MEMORY_TERMINAL    .
                                                 //                 MEMORY_WINDOW      .
                          uchar &szPrefixArea[], //         .
                          int    nIndex,         //   .   ,   .
                          uchar &szName[],       //   .
                          int    nStartByte,     //      ,      .
                          int   &aiArray[],      //          INT (4 )   .
                          int    nSizeArray,     //   (  ).
                          int    nStart,         //       (   ).
                          int    nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.6.2.        INT (4 )    INT (4 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryReadIntArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                              //                 MEMORY_TERMINAL    .
                                              //                 MEMORY_WINDOW      .
                          string sPrefixArea, //         .
                          int    nIndex,      //   .   ,   .
                          string sName,       //   .
                          int    nStartByte,  //      ,      .
                          int   &aiArray[],   //          INT (4 )   .
                          int    nSizeArray,  //   (  ).
                          int    nStart,      //       (   ).
                          int    nCount);     //    .
 //=======================================================================================================================================================================
 // 7.7.1.        UINT (4 )    UINT (4 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryReadUIntArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                  //                 MEMORY_TERMINAL    .
                                                  //                 MEMORY_WINDOW      .
                           uchar &szPrefixArea[], //         .
                           int    nIndex,         //   .   ,   .
                           uchar &szName[],       //   .
                           int    nStartByte,     //      ,      .
                           uint  &auiArray[],     //          UINT (4 )   .
                           int    nSizeArray,     //   (  ).
                           int    nStart,         //       (   ).
                           int    nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.7.2.        UINT (4 )    UINT (4 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryReadUIntArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                           string sPrefixArea, //         .
                           int    nIndex,      //   .   ,   .
                           string sName,       //   .
                           int    nStartByte,  //      ,      .
                           uint &auiArray[],   //          UINT (4 )   .
                           int    nSizeArray,  //   (  ).
                           int    nStart,      //       (   ).
                           int    nCount);     //    .
 //=======================================================================================================================================================================
 // 7.8.1.        INT64 (8 )    INT64 (8 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryReadLongArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                  //                 MEMORY_TERMINAL    .
                                                  //                 MEMORY_WINDOW      .
                           uchar &szPrefixArea[], //         .
                           int    nIndex,         //   .   ,   .
                           uchar &szName[],       //   .
                           int    nStartByte,     //      ,      .
                           long  &alArray[],      //          INT64 (8 )   .
                           int    nSizeArray,     //   (  ).
                           int    nStart,         //       (   ).
                           int    nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.8.2.        INT64 (8 )    INT64 (8 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryReadLongArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                               //                 MEMORY_TERMINAL    .
                                               //                 MEMORY_WINDOW      .
                           string sPrefixArea, //         .
                           int    nIndex,      //   .   ,   .
                           string sName,       //   .
                           int    nStartByte,  //      ,      .
                           long  &alArray[],   //          INT64 (8 )   .
                           int    nSizeArray,  //   (  ).
                           int    nStart,      //       (   ).
                           int    nCount);     //    .
 //=======================================================================================================================================================================
 // 7.9.1.        UINT64 (8 )    UINT64 (8 )     .
 //          TRUE     - FALSE.    ANSI-.
 BOOL MemoryReadULongArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                            uchar &szPrefixArea[], //         .
                            int    nIndex,         //   .   ,   .
                            uchar &szName[],       //   .
                            int    nStartByte,     //      ,      .
                            ulong &aulArray[],     //          UINT64 (8 )   .
                            int    nSizeArray,     //   (  ).
                            int    nStart,         //       (   ).
                            int    nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.9.2.        UINT64 (8 )    UINT64 (8 )     .
 //          TRUE     - FALSE.    UNICODE-.
 BOOL MemoryReadULongArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                            string sPrefixArea, //         .
                            int    nIndex,      //   .   ,   .
                            string sName,       //   .
                            int    nStartByte,  //      ,      .
                            ulong &aulArray[],  //          UINT64 (8 )   .
                            int    nSizeArray,  //   (  ).
                            int    nStart,      //       (   ).
                            int    nCount);     //    .
 //=======================================================================================================================================================================
 // 7.10.1.        FLOAT (4 )    FLOAT (4 )     .
 //             FLOAT (4 )     DOUBLE (8 )    .
 //           TRUE     - FALSE.    ANSI-.
 BOOL MemoryReadFloatArrayA(int    nArea,          //  : MEMORY_GLOBAL      .
                                                   //                 MEMORY_TERMINAL    .
                                                   //                 MEMORY_WINDOW      .
                            uchar &szPrefixArea[], //         .
                            int    nIndex,         //   .   ,   .
                            uchar &szName[],       //   .
                            int    nStartByte,     //      ,      .
                            float &afArray[],      //          FLOAT (4 )   .
                            int    nSizeArray,     //   (  ).
                            int    nStart,         //       (   ).
                            int    nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.10.2.        FLOAT (4 )    FLOAT (4 )     .
 //             FLOAT (4 )     DOUBLE (8 )    .
 //           TRUE     - FALSE.    UNICODE-.
 BOOL MemoryReadFloatArrayW(int    nArea,       //  : MEMORY_GLOBAL      .
                                                //                 MEMORY_TERMINAL    .
                                                //                 MEMORY_WINDOW      .
                            string sPrefixArea, //         .
                            int    nIndex,      //   .   ,   .
                            string sName,       //   .
                            int    nStartByte,  //      ,      .
                            float &afArray[],   //          FLOAT (4 )   .
                            int    nSizeArray,  //   (  ).
                            int    nStart,      //       (   ).
                            int    nCount);     //    .
 //=======================================================================================================================================================================
 // 7.11.1.        DOUBLE (8 )    DOUBLE (8 )     .
 //           TRUE     - FALSE.    ANSI-.
 BOOL MemoryReadDoubleArrayA(int     nArea,          //  : MEMORY_GLOBAL      .
                                                     //                 MEMORY_TERMINAL    .
                                                     //                 MEMORY_WINDOW      .
                             uchar  &szPrefixArea[], //         .
                             int     nIndex,         //   .   ,   .
                             uchar  &szName[],       //   .
                             int     nStartByte,     //      ,      .
                             double &adArray[],      //          DOUBLE (8 )   .
                             int     nSizeArray,     //   (  ).
                             int     nStart,         //       (   ).
                             int     nCount);        //    .
 //-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.11.2.        DOUBLE (8 )    DOUBLE (8 )     .
 //           TRUE     - FALSE.    UNICODE-.
 BOOL MemoryReadDoubleArrayW(int     nArea,       //  : MEMORY_GLOBAL      .
                                                  //                 MEMORY_TERMINAL    .
                                                  //                 MEMORY_WINDOW      .
                             string  sPrefixArea, //         .
                             int     nIndex,      //   .   ,   .
                             string  sName,       //   .
                             int     nStartByte,  //      ,      .
                             double &adArray[],   //          DOUBLE (8 )   .
                             int     nSizeArray,  //   (  ).
                             int     nStart,      //       (   ).
                             int     nCount);     //    .
 //
#import
//
/*

22.11.2012.  2.11.22.3.
1.      ,  UNICODE-.
2.    .    .

05.12.2012.  2.12.5.1.
1.        UNICODE-.     .

16.07.2013.  3.7.16.1.
1.    MemoryWriteBoolArray(), MemoryWriteCharArray(), MemoryWriteUnsCharArray(), MemoryWriteShortArray(), MemoryWriteUnsShortArray(), MemoryWriteFloatArray()
     MemoryWriteIntToBoolArray(), MemoryWriteIntToCharArray(), MemoryWriteIntToUnsCharArray(), MemoryWriteIntToShortArray(), MemoryWriteIntToUnsShortArray(), MemoryWriteDoubleToFloatArray()  MQL4.
2.    MemoryReadBoolArray(), MemoryReadCharArray(), MemoryReadUnsCharArray(), MemoryReadShortArray(), MemoryReadUnsShortArray(), MemoryReadFloatArray()
     MemoryReadBoolToIntArray(), MemoryReadCharToIntArray(), MemoryReadUnsCharToIntArray(), MemoryReadShortToIntArray(), MemoryReadUnsShortToIntArray(), MemoryReadFloatToDoubleArray()  MQL4.
3.      MQL5.
4.       :  , ANSI, UNICODE.  4      "A" (ANSI).  5      "W" (UNICODE).
5.    MQL5      MemoryWriteBoolArray(), MemoryWriteCharArray(), MemoryWriteUnsCharArray(), MemoryWriteShortArray(),
   MemoryWriteUnsShortArray(), MemoryWriteUnsIntArray(), MemoryWriteLongArray(), MemoryWriteUnsLongArray(), MemoryWriteFloatArray().
6.    MQL5      MemoryReadBoolArray(), MemoryReadCharArray(), MemoryReadUnsCharArray(), MemoryReadShortArray(),
   MemoryReadUnsShortArray(), MemoryReadUnsIntArray(), MemoryReadLongArray(), MemoryReadUnsLongArray(), MemoryReadFloatArray().
7.         .

07.02.2014.  4.2.7.1.
1.       .      MQL4  MQL5.
2.   ,     .   "Uns"   "U".

*/